/***************************************************************************
 *   Copyright (C) 2006 by jkeller   *
 *   jkeller@localhost   *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/

#define Complex  std::complex<double>
#define _Complex_I std::complex<double>(0, 1)
#define _1  (std::complex<double>(1, 0))
#define _I  (std::complex<double>(0, 1))
#define _2  (std::complex<double>(2, 0))
#define _0  (std::complex<double>(0, 0))
#define PI  3.14159265358979323846

#define pow2(x) (x*x)
#define pow3(x) (x*x*x)
#define pow4(x) pow2(x*x)
#define pow5(x) (x*pow4(x))
#define pow6(x) pow2(pow3(x))
#define pow7(x) x*pow6(x)
#define pow8(x) pow2(pow4(x))
#include "computevol.h"

/* We rename complex numbers */
#define Complex  std::complex<double>



double FNBigcut2(double ax,double ay, double az)
{
  double Bt,Bz,Bx,By;
  Bt = (1 - FNCut(parameter1_FNcut, parameter2_FNcut, ax)) * (1 - FNCut(parameter1_FNcut,parameter2_FNcut, ay)) * (1 - FNCut(parameter1_FNcut,parameter2_FNcut, az));
  Bz =(az > 0)?  (1 - FNCut(parameter1_FNcut, parameter2_FNcut, 1/az)) * (1 - FNCut(parameter1_FNcut,parameter2_FNcut, ax/az))*(1-FNCut(parameter1_FNcut,parameter2_FNcut, ay/az)):0;
  Bx= (ax > 0)? (1 - FNCut(parameter1_FNcut,parameter2_FNcut, 1 / ax)) * (1 - FNCut(parameter1_FNcut, parameter2_FNcut, ay / ax)) * (1 - FNCut(parameter1_FNcut,parameter2_FNcut, az/ax)) :0;
  By= (ay > 0)? (1 - FNCut(parameter1_FNcut, parameter2_FNcut, 1 / ay)) * (1 - FNCut(parameter1_FNcut, parameter2_FNcut, ax / ay))* (1 - FNCut(parameter1_FNcut,parameter2_FNcut, az/ay)):0;
  return(Bt / (Bx + By + Bz + Bt));
}




double FNBigcut(double ax,double ay)
{
  double Bz,Bx,By;

  Bz = (1 - FNCut(parameter1_FNcut, parameter2_FNcut, ax)) * (1 - FNCut(parameter1_FNcut,parameter2_FNcut, ay));
  Bx= (ax > 0)? (1 - FNCut(parameter1_FNcut,parameter2_FNcut, 1 / ax)) * (1 - FNCut(parameter1_FNcut, parameter2_FNcut, ay / ax)):0;
  By= (ay > 0)? (1 - FNCut(parameter1_FNcut, parameter2_FNcut, 1 / ay)) * (1 - FNCut(parameter1_FNcut, parameter2_FNcut, ax / ay)):0;
  return(Bz / (Bx + By + Bz));
}




double FNCut (double a,double b,double x)
{
  if(x < a)
  {
    return(0);
  }
  if(x > b)
  {
    return(1);
  }
  if(x >= a && x <= b)
  {
    return(.5 * (1 - cos((x - a) / (b - a) * PI)));
  }
}



int main(int argc, char **argv)
{
  double Numx=70.;  // big chart
  double Nump=70.;
  double Numv=30.; //small chart
  double Numw=30.;
  //	time_t seconds;      /* time of computation */
  //	time(NULL);
  //	seconds = time (NULL);
  long compt=0;
  //printf("%f ",seconds);
  int i,j,k,l,m;
  int combinv;
  Complex v,ZA,w,x,x6,y6;
  double alpha,hbot,lbot,lbot_sign,combinw,Wt,Cof,chix,chiy,nw,nx,ny;
  double hmax,hmaxint;
  double mass=0;
  double mass01=0;
  double mass02=0;
  //small chart
  for(i=0;i<(Numv / 2.) +1;i++)
  {
    if(pow2(i * rad / Numv) <= rad / 2.)
    {
      hmax= rad/2. + sqrt(pow2(rad / 2.)-pow2(i * rad / Numv));
      hmaxint = ((hmax / rad)*Numv) + 1;
    }
    for(j=0;j<hmaxint+1;j++)
    {
      Complex v=Complex (i*rad/Numv,(j * rad) / Numv);
      (i==0) ? (combinv=(j==0)? 1:2) : (combinv=(j==0)? 2:4) ;
      ZA=Complex(0.5,0)*(Complex((1 - 2 * parameter_smallchart),rad) - v);
      //alpha = (real(ZA)+ abs(ZA) < 0)? 0 : sqrt(real(ZA) + abs(ZA));
      for(k = 0;k<(Numw)/2;k++)
      {
        hbot = (pow2(rad*k/Numw) <= 2 * real(ZA)) ? 0 : sqrt(pow2(rad*k/Numw) - 2. * real(ZA));
        // lbot = floor(hbot * Numw);
        lbot = (hbot * Numw);

        // for(m= 0;m<1;m++)
        // {
        //     lbot_sign = ((m==0)?1:-1) * (lbot -  1) ;
        lbot_sign = lbot -  1 ;
        l = 0;
        do  /*un while ?*/
        {
          l = l + 1;
          // lbot_sign = lbot_sign +  (-2*m+1) ;
          lbot_sign ++;
          //combinw = 2;
          (k==0)? (combinw=(lbot_sign==0)? 1:2) : (combinw=(lbot_sign==0)? 2:4);

          w=Complex(rad*k/Numw ,lbot_sign/Numw);
          x= pow((Complex (0.5,0)) * (pow2(w)+v-_1),Complex (1/6.,0));
          nx =abs(x);
          ny =pow(0.5* abs(pow2(w)-v-_1),1/6.);
          y6 = 0.5* (pow2(w) - v - _1);
          chiy = 1 - FNCut(parameter_smallchart, parameter_bigchart, -real(y6));  //cut-off
          x6 = 0.5* (pow2(w) + v - _1),
               chix = 1 - FNCut(parameter_smallchart, parameter_bigchart, -real(x6));
          Cof = (1 - chix) * (1 - chiy) * FNBigcut(nx, ny);
          if (Cof!=0)
          {
            Wt =(nx*ny==0)?0:pow4(rad)/(pow2(36. * pow5(nx*ny)*(Numv*Numw))); //holomorph form
            mass +=Cof * (36. * combinv * combinw) * Wt;
            mass01+=Cof * (36. * combinv * combinw) * Wt;
            compt++;
          }
        }
        while (Cof!=0) ;
        //	while (Cof !=0 || ! (l> (0.2*Numw) || Cof>0));
        //}
      }
    }
  }
  double defect;
  int combinx,combinp;
  Complex p6,p;
  double S_x;
  double chiconj,norm;
  radius1=rad;
  for(i = 0;i<Numx+1;i++)
  {
    j = -1;
    do
    {

      j = j + 1;

      //combinx=(i==0 && j==0)?1:((i==0 && j>0)?0:6);
      (i==0)? (combinx=(j==0)? 1:3) : (combinx=(j==0)? 3:6);
      x=Complex(i*radius1/Numx+.5 *j*radius1/Numx, ((sqrt(3.)/2.)*j*radius1 / Numx));
      nx = abs(x);
      x6=pow6(x);
      chix = 1 - FNCut(parameter_smallchart, parameter_bigchart, -real(x6));
      for(k=0;k<Nump+1;k++)
      {
        l = -1;
        do
        {
          l = l + 1;
          p=Complex(radius1 * ((k / Nump) + l * (.5 / Nump)), (radius1 * (l / Nump) * sqrt(3.) / 2));
          (k==0)? (combinp=(l==0)? 1:3) : (combinp=(l==0)? 3:6);
          p6=pow6(p);
          S_x=abs(_1+x6);
          ny=abs(p)*pow(S_x*abs(_2+p6),1/6.);
          nw =  abs(_1+p6)* sqrt(S_x);
          y6=((p6+_2)*p6)*(_1+x6);
          chiy = 1 - FNCut(parameter_smallchart, parameter_bigchart, -real(y6));
          norm= (l-k);
          chiconj = 1 - FNCut(-parameter3_FNcut,parameter3_FNcut, norm);
          Cof = FNBigcut(nx, ny) * FNCut(-.99, .99, real(p6) + 1) * chix * (2 - chiy) * chiconj;
          if(Cof!=0)
          {

            Wt=(S_x*abs(_2+p6)==0)?0:pow4(radius1)*3.*pow(S_x,-2/3.)*pow(abs(_2+p6),-5/3.)/(pow2(Nump*Numx));

            //norm= -.5 * real(p) +sqrt(3.) * (.5) * imag(p);

            //chiconj=(k>l+parameter3_FNcut)?1:0;

            mass+= Wt * Cof * (4. * combinp * combinx);
            mass02+=Wt * Cof * (4. * combinp * combinx);
            compt++;
          }

        }
        while (Cof!=0);

        //	while(abs(p6)*abs(_2+p6) < pow6(1.2)/S_x && real(p6)>= -1.5 && chiconj != 0 && chix != 0
        //		 );
      }

    }
    while(chix != 0 && nx < 1.2);
  }
  mass = 12 * mass;
  printf("\n Volume K3 : %f  in %d  %f %f\n",mass,compt,12*mass01,12*mass02);

  /*
  double mass2=0;
  Complex dx0,dy0,x0,y0;
  double x0r,x0i,y0r,y0i,dx0r,dx0i,dy0r,dy0i,temp,nmb;
  double Size=1.3;
  dx0r=0.1;
  dy0r=0.1;
  dx0i=0.1;
  dy0i=0.1;
  dx0=Complex(dx0r,dy0i);
  dy0=Complex(dy0r,dy0i);
  nmb=0;
  for(x0r=-Size;x0r<Size;x0r+=dx0r)
  {
      printf("%f %\n",100.*(x0r+Size)/(2.*Size));  
      for(x0i=-Size;x0i<Size;x0i+=dx0i)
    {
        for(y0r=-Size;y0r<Size;y0r+=dy0r)
      {
          for(y0i=-Size;y0i<Size;y0i+=dy0i)
        {
            if(abs(Complex(x0r,x0i))<1.2 &&   abs(Complex(y0r,y0i))<1.2){
                nmb++;
                temp=abs(pow6(Complex(x0r,x0i))+pow6(Complex(y0r,y0i))+_1);
                if (temp!=0 and temp<pow2(1.2))
                {
                 mass2+=pow2(abs(dx0*dy0))/temp;
                }
            }   
        }
      }
    }
  }
  printf("\ncomputed : masse = %f", mass2/nmb);

  */









  //	seconds=time(NULL)-seconds;
  //	printf("\n-- Time of computation : %f %f sec \n",seconds);
  //	cout << seconds << endl;

  // small chart CY
  time_t seconds=time (NULL);
  mass=0;
  compt=0;
  Numx=35.;
  Nump=35.; 
  Numv=20.; //small chart
  Numw=20.;
  printf("Precision : %f  %f  | %f  %f \n",Numx,Nump,Numv,Numw);

  Complex v2,ZA2,z,z6,v1;
  double alpha2,hbot2,lbot2,lbot_sign2,nz,chiz;
  double hmax2,hmaxint2;
  double coeff1,coeff2,coeff3,coeff4;
  Complex t,t8,x8,p8,y8,z8;
  double chit,S_t,chi2;
  int i1,j1,combint,combinv1;
  int i2,j2;
  double chiconj2;
  double mass1,mass2,mass3,mass4;
  mass1=0;mass2=0;mass3=0;mass4=0;
  //small chart  x small (1+t^8) not small
  //radius2=rad2;  //works also
  coeff2=pow5(rad2)/(pow(2,20)*(pow2(Numw)*pow4(Numv)));
  coeff1=(1./sqrt(2))*pow3(rad2)*pow2(radius2)/(pow(2,12)*pow2(Numx*Numw*Numv));
  
  for(i=0;i<(Numv / 2.) +1;i++)
  {
    if(pow2(i * rad2 / Numv) <= rad2 / 2.)
    {
      hmax= rad2/2. + sqrt(pow2(rad2 / 2.)-pow2(i * rad2 / Numv));
      hmaxint = ((hmax / rad2)*Numv) + 1;
    }
    //printf("%f ",hmaxint);
    for(j=0;j<hmaxint+1;j++)
    {
      Complex v=Complex (i*rad2/Numv,(j * rad2) / Numv);
      (i==0) ? (combinv=(j==0)? 1:2) : (combinv=(j==0)? 2:4) ;

      ZA=Complex(1./2.,0)*(Complex((1 - 2. * parameter_smallchart2),rad2) - v);

      //       ZA2=Complex(1./3.,0)*(Complex((1 - 3 * parameter_smallchart),rad) - v2);
      //	alpha = (real(ZA)+ abs(ZA) < 0)? 0 : sqrt(real(ZA) + abs(ZA));
      //       alpha2 = (real(ZA2)+ abs(ZA2) < 0)? 0 : sqrt(real(ZA2) + abs(ZA2));

      for(k = 0;k<Numw/2;k++)
      {
        hbot = (pow2(rad2*k/Numw) <= 2 * real(ZA)) ? 0 : sqrt(pow2(rad2*k/Numw) - 2. * real(ZA));
        //lbot = floor(hbot * Numw);
        lbot=hbot*Numw;
        lbot_sign=lbot-1;
        l = 0;



        do
        {
          l = l + 1;
          lbot_sign++;
          (k==0)? (combinw=(lbot_sign==0)? 1:2) : (combinw=(lbot_sign==0)? 2:4);
          w=Complex(rad2*k/Numw ,lbot_sign/Numw);
          ///norm= (l-k);
          chiconj = 1 - FNCut(-parameter3_FNcut2,parameter3_FNcut2, l-k);

          for(i1 = 0;i1<Numx+1;i1++)
          {
            j1 = -1;
            do
            {

              j1 = j1 + 1;

              //combinx=(i==0 && j==0)?1:((i==0 && j>0)?0:8);
              (i1==0)? (combint=(j1==0)? 1:4) : (combint=(j1==0)? 4:8);
              t=Complex(i1*radius2/Numx,0)+exp(_I*PI/4.)*Complex(j1*radius2/Numx,0);
              t8=pow8(t);
              S_t=abs(_1+t8);
              x8= ((Complex (1./2.,0)) * (pow2(w)+v-_1));
              nx = pow(abs(x8),1./8.);
              y8 = ((Complex (1./2.,0)) * (pow2(w)-v-_1))/(_1+t8);
              ny=  pow(abs(y8),1./8.);
              ///z8= y8*t8;
              nz= ny*abs(t);
              //holomorph form
              
              
              chiconj2 = 1 - FNCut(-parameter3_FNcut2,parameter3_FNcut2, j1-i1);
              
              //chix =  FNCut(parameter_smallchart2, parameter_bigchart2, 1.-real(x8));
              //chi2 = 1 - FNCut(parameter_smallchart2, parameter_bigchart2, -real(x8*y8*(_1+t8))); 
              //chi2 = 1- FNCut(-.99, .99, real(z8 +y8) )*FNCut(-.99, .99, -real(z8 + y8)); 
              //cut-off
              //chiz = 1 - FNCut(parameter_smallchart2, parameter_bigchart2, -real(_1+t8));
              //chiz = 1- FNCut(-.99, .99, real(_1 +t8) )*FNCut(-.99, .99, -real(_1 + t8)); 
              //chix = 1- FNCut(-.99, .99, real(x8*(y8+z8) ))*FNCut(-.99, .99, -real(x8*(y8+z8))); 
              chix=FNCut(parameter_smallchart2, parameter_bigchart2, 1.-real(x8));
              chiy=FNCut(parameter_smallchart2, parameter_bigchart2, 1.-real(y8));
              chit=1-FNCut(parameter_smallchart2, parameter_bigchart2, 1.-real(_1+t8));
           //   chiz=1-FNCut(parameter_smallchart2, parameter_bigchart2, 1.-real(x8*(y8+z8)));
              
              Cof = chix* chit * chiconj * FNBigcut2(nx, ny, nz)* chiconj2;
              //printf("\n %f %f %f | %f",chiconj,1-chix,1-chiy,FNBigcut2(nx, ny, nz));
              if (Cof!=0)
              {
                  //printf("OK1");
                
                Wt=coeff1/(pow2(S_t)*pow2(pow7(nx)*pow6(ny)));
             //   mass+=Cof * (2*8*8 * combinv * combinw * combint) * Wt;
                mass1+=Cof * (2*8*8 * combinv * combinw * combint) * Wt;
                compt++;
              }
            }
            while(chit != 0 && abs(t) <= 1.2);
          }
        }
        while(Cof!=0);
        
        
        l=0;
        do
        {
          l = l + 1;
          lbot_sign++;
          (k==0)? (combinw=(lbot_sign==0)? 1:2) : (combinw=(lbot_sign==0)? 2:4);
          w=Complex(rad2*k/Numw ,lbot_sign/Numw);
          chiconj = 1 - FNCut(-parameter3_FNcut2,parameter3_FNcut2, l-k);
          //2nd small chart
          for(i1=0;i1<(Numv / 2.) +1;i1++)
          {
            if(pow2(i1 * rad2 / Numv) <= rad2 / 2.)
            {
              hmax= rad2/2. + sqrt(pow2(rad2 / 2.)-pow2(i1 * rad2 / Numv));
              hmaxint = ((hmax / rad2)*Numv) + 1;
            }
            for(j1=0;j1<hmaxint+1;j1++)
            {
              Complex v1=Complex (i1*rad2/Numv,(j1 * rad2) / Numv);
              (i1==0) ? (combinv1=(j1==0)? 1:2) : (combinv1=(j1==0)? 2:4) ;
              x8= ((Complex (1./2.,0)) * (pow2(w)+v-_1));
              chix = FNCut(parameter_smallchart2, parameter_bigchart2, 1-real(x8));
              //chix = 1 - FNCut(parameter_smallchart2, parameter_bigchart2, -real(x8));
              nx=  pow(abs(x8),1./8.);
              y8 = ((Complex (1./4.,0)) * (pow2(w)-v-_1-_2*v1));
              chiy = FNCut(parameter_smallchart2, parameter_bigchart2, 1-real(y8));
              //chiy= 1 - FNCut(parameter_smallchart2, parameter_bigchart2, -real(y8));
              z8= ((Complex (1./4.,0)) * (pow2(w)-v-_1+_2*v1));
              chiz = FNCut(parameter_smallchart2, parameter_bigchart2, 1-real(z8));
              //chiz= 1 - FNCut(parameter_smallchart2, parameter_bigchart2, -real(z8));
              ny=  pow(abs(y8),1./8.);
              nz=  pow(abs(z8),1./8.);
              //chi2 = 1 - FNCut(parameter_smallchart2, parameter_bigchart2, -real(y8+z8));
              Cof =  chix * chiy * chiz * FNBigcut2(nx, ny, nz) * chiconj;
              if (Cof!=0)
              {
                Wt=coeff2/(pow2(pow7(nx*ny*nz)));
                //mass+=Cof * (8*8*8 * combinv * combinw * combinv1) * Wt;
                mass2+=Cof * (8*8*8 * combinv * combinw * combinv1) * Wt;
                compt++;
              }
            }
          }
        }
        while (Cof !=0);
      }
    }

}
  printf("1rst charts done \n ");
 
  // big charts
  ///coeff3=2*sqrt(2)*pow6(radius2)/(pow4(Numx)*pow2(Nump));
  coeff3=2*pow6(radius2)/(pow4(Numx)*pow2(Nump));
  ///coeff4=(1/sqrt(2.))*pow2(rad2*pow2(radius2))/(pow6(2)*pow2(Numx*Numv*Nump));
  coeff4=(1./sqrt(2.))*2*pow2(rad2*pow2(radius2))/(pow2(Numx*Numv*Nump));
  for(i = 0;i<Numx+1;i++)
  {
    j = -1;
    do
    {

      j = j + 1;

      //combinx=(i==0 && j==0)?1:((i==0 && j>0)?0:8);
      (i==0)? (combinx=(j==0)? 1:4) : (combinx=(j==0)? 4:8);
      x=Complex(i*radius2/Numx,0)+exp(_I*PI/4.)*Complex(j*radius2/Numx,0);
      nx = abs(x);
      x8=pow8(x);
      chix = 1 - FNCut(parameter_smallchart2, parameter_bigchart2, -real(x8));
      S_x=abs(_1+x8);
      chiconj2=1 - FNCut(-parameter3_FNcut2,parameter3_FNcut2, j-i);
             
      // ici (1+t^8) and (1+x^8) not small  ---> 1rst chart
      
      for(i1=0;i1<Numx+1;i1++)
      {
        j1=-1;
        do
        {
          j1++;
          (i1==0)? (combint=(j1==0)? 1:4) : (combint=(j1==0)? 4:8);
          //combint=(i1==0 && j1==0)?1:((i1==0 && j1>0)?0:8);
          t=Complex(i1*radius2/Numx,0)+exp(_I*PI/4.)*Complex(j1*radius2/Numx,0);
          t8=pow8(t);
          chi2 =1 - FNCut(parameter_smallchart2, parameter_bigchart2, -real((_1+t8)));
          S_t=abs(_1+t8);
          //chit=1 - FNCut(parameter_smallchart, parameter_bigchart, -real(t8));
          for(k=0;k<Nump+1;k++)
          {
            l = -1;
            do
            {
              l = l + 1;
              p=Complex(radius2*(k/Nump),0)+exp(_I*PI/4.)*Complex(l*radius2/Nump,0);
              //(k==0)? (combinp=(l==0)? 1:4) : (combinp=(l==0)? 4:8);
              (k==0)? (combinp=(l==0)? 1:4) : (combinp=(l==0)? 4:8);
              p8=pow8(p);

              ny=abs(p)*pow(S_x*abs(_2+p8)/S_t,1/8.);  //improved from original
              nz=ny*abs(t);
              ///nw=abs(_1+p8)* sqrt(S_x);
              ///y8=((p8+_2)*p8)*(_1+x8)/(_1+t8);
              

              //pow6(radius2)*(9./4.)/(sqrt(S_x*S_t*pow3(abs(_2+p8)))*pow2(Nump)*pow4(Numx)); // 9/4=9/16 *4 ??
              //P-Err
              ///norm= l-k; //-(sqrt(2.)/2.)* real(p) +(sqrt(2.)/2.)* imag(p);
              chiconj = 1 - FNCut(-parameter3_FNcut2,parameter3_FNcut2, l-k);
             
              Cof = FNBigcut2(nx, ny, nz) * FNCut(-.99, .99, real(p8) + 1)* chix * chi2 * chiconj*chiconj2;
              //a quoi correspond chiy,chiconj ?
              //P-Err
              if (Cof!=0)
              {
                Wt=coeff3*pow2(abs(p))/sqrt(pow3(abs(_2+p8))*S_x*S_t);
               // mass+= Wt * Cof * (8. * combinp * combinx * combint);
                mass3+= Wt * Cof * (8. * combinp * combinx * combint);
                compt++;
              }
            }
            while (Cof!=0);
         
          }

        }
        while(chit != 0 && abs(t) <= 1.2);
        //while(chit != 0 && abs(t) <= 1.2/(parameter3_FNcut*pow(2.,1./6.)));

      }
            // ici t=z/y and (1+x^8) not small, v=y^8-z^8
      Complex Exprp;

      for(i1=0;i1<(Numv / 2.) +1;i1++)
      {
        if(pow2(i1 * rad2 / Numv) <= rad2 / 2.)
        {
          hmax= rad2/2. + sqrt(pow2(rad2 / 2.)-pow2(i1 * rad2 / Numv));
          hmaxint = ((hmax / rad2)*Numv) + 1;
        }        
        for(j1=0;j1<hmaxint+1;j1++)
        {
          Complex v=Complex (i1*rad2/Numv,(j1 * rad2) / Numv);
          (i1==0) ? (combinv=(j1==0)? 1:2) : (combinv=(j1==0)? 2:4) ;
          ZA=Complex(0.5,0)*(Complex((1- 2 * parameter_smallchart),rad2) - v);

          for(k = 0;k<Nump/2.;k++)
          {
            hbot = (pow2(rad2*k/Nump) <= 2 * real(ZA)) ? 0 : sqrt(pow2(rad2*k/Nump) - 2. * real(ZA));
            lbot = (hbot * Nump);
            lbot_sign = lbot -  1 ;
            l = 0;
            do
            {
              l = l + 1;
              lbot_sign ++;
              (k==0)? (combinp=(lbot_sign==0)? 1:2) : (combinp=(lbot_sign==0)? 2:4);
              p=Complex(radius2*(k/Nump),0)+exp(_I*PI/4.)*Complex(l*radius2/Nump,0);
              p8=pow8(p);
              //Exprp=Complex(rad2*k/Numw ,lbot_sign/Numw); //=p8*(2+p8)*(1+x8)
              Exprp=p8*(_2+p8)*(_1+x8);
              y8=Complex(0.5,0.)*(Exprp+v);
              ny=pow(abs(y8),1./8.);
              z8=Complex(0.5,0.)*(Exprp-v);
              nz=pow(abs(z8),1./8.);
              
             /// chiy = 1-FNCut(parameter_smallchart2,parameter_bigchart2, -real(y8));
            ///  chiz = 1-FNCut(parameter_smallchart2,parameter_bigchart2, -real(z8));
              //chi2=1- FNCut(parameter_smallchart2, parameter_bigchart2, -real(_1+z8/y8));
              //chi2= FNCut(-2,2,  real(z8/y8) + 1)*FNCut(-2,2, -real(z8/y8) - 1); 
              chiy = FNCut(parameter_smallchart2,parameter_bigchart2, real(y8));
              chiz = FNCut(parameter_smallchart2,parameter_bigchart2, -real(z8));
             chi2 =  FNCut(-0.99,0.99, real(z8/y8) + 1)*FNCut(-0.99,0.99, -real(z8/y8) - 1);
              //chi2 =  FNCut(-.99, .99, real(z8/y8) + 1);
              norm= l-k; //-(sqrt(2.)/2.)* real(p) +(sqrt(2.)/2.)* imag(p);
              chiconj = 1 - FNCut(-parameter3_FNcut2,parameter3_FNcut2, norm);
             
              //cut-off
             // printf("\n %f %f %f | %f",1-chi2,chix,chiz,FNBigcut2(nx, ny, nz));
              Cof =    chix * chiz * chiy * chi2* chiconj* FNBigcut2(nx, ny,nz)*chiconj2;
              if(Cof!=0)
              {

                  Wt=S_x*pow2(pow7(abs(p)/(ny*nz)));
                  //printf("\n coeff4 %f, S_x %f, pow2(pow7(abs(p)/(ny*nz))) = %f",coeff4,S_x,pow2(pow7(abs(p)/(ny*nz))));
              //  mass +=Cof * (2*8*8 * combinx * combinp * combinv) * Wt;
                mass4 +=Cof * (combinx * combinp * combinv) * Wt;
                
                // P-Err
                compt++;
              }
            }
            while (Cof!=0 && ny<=1.2 && nz<=1.2);

          }
        }
      }


    }
    while(chix != 0 && nx <= 1.2); //P-Err
    
  }
  mass4=coeff4*mass4*2*8*8;
  mass+=mass1+mass2+mass3+mass4;
  mass = 16 * mass;
  printf(" Volume CY : %f  in %d pts and %d sec ||  %f %f %f %f\n \n",mass,compt,seconds=time (NULL)-seconds,16*mass1,16*mass2,16*mass3,16*mass4);
}





///////////////////////////////////////////////////////////////////
/*
for(i=0;i<(Numv / 2.) +1;i++)
{
   if(pow2(i * rad / Numv) <= rad / 2.)
   {
       hmax= rad/2. + sqrt(pow2(rad / 2.)-pow2(i * rad / Numv));
       hmaxint = ((hmax / rad)*Numv) + 1;
   }
   for(j=0;j<hmaxint+1;j++)
   {
       Complex v1=Complex (i*rad/Numv,(j * rad) / Numv);
		//CY case
       for(i2=0;i2<(Numv / 2.) +1;i2++)
       {
           if(pow2(i2 * rad / Numv) <= rad / 2.)
           {
               hmax2= rad/2. + sqrt(pow2(rad / 2.)-pow2(i2 * rad / Numv));
               hmaxint2 = ((hmax2 / rad)*Numv) + 1;
           }
           for(j2=0;j2<hmaxint2+1;j2++)
           {
               Complex v2=Complex (i2*rad/Numv,(j2 * rad) / Numv);
				//CY end		
				
               (i==0) ? (combin=(j==0)? 1:2) : (combin=(j==0)? 2:4) ;
           
           
               ZA=Complex(1./3.,0)*(Complex((1 - 3. * parameter_smallchart),rad) - v1);
    //       ZA2=Complex(1./3.,0)*(Complex((1 - 3 * parameter_smallchart),rad) - v2);
			//	alpha = (real(ZA)+ abs(ZA) < 0)? 0 : sqrt(real(ZA) + abs(ZA));
    //       alpha2 = (real(ZA2)+ abs(ZA2) < 0)? 0 : sqrt(real(ZA2) + abs(ZA2));
           
               for(k = 0;k<(rad* Numw)/2;k++)
               {
                   hbot = (pow2(rad*k/Numw) <= 2 * real(ZA)) ? 0 : sqrt(pow2(rad*k/Numw) - 2. * real(ZA));
					//lbot = floor(hbot * Numw);
                   lbot=hbot*Numw;
					//for(m= 0;m<2;m++)
					//{
						//lbot_sign = ((m==0)?1:-1) * lbot -  ((m==0)?1:-1) ;
                   lbot_sign=lbot-1;
                   l = 0;
                   do  /*un while ?*/
/*             {
                 l = l + 1;
	//lbot_sign = lbot_sign +  (-2*m+1) ;
                 lbot_sign++;
                 (k==0)? (combinw=(lbot_sign==0)? 1:2) : (combinw=(lbot_sign==0)? 2:4);
                 w=Complex(rad*k/Numw ,lbot_sign/Numw);
                 x= pow((Complex (1./3.,0)) * (pow2(w)+v1-_1),Complex (1/8.,0));
                 nx =abs(x);
                 ny =pow((1./3.)* abs(pow2(w)-v1-v2-_1),1/8.);
                 z= pow((Complex (1./3.,0)) * (pow2(w)+v2-_1),Complex (1/8.,0));
                 nz=abs(z);
                 Wt=(nx*ny*nz==0)?0:pow4(rad)/(pow2((9.*pow(2.,8.)*pow7(nx*ny*nz))*pow2(Numv*Numw*Numv))); //holomorph form
                 x6 = (1./3.)* (pow2(w) + v1 - _1),
                 y6 = (1./3.)* (pow2(w) - v1 -v2 - _1);
                 z6 = (1./3.)* (pow2(w) + v2 - _1);
                 chix = 1 - FNCut(parameter_smallchart, parameter_bigchart, -real(x6));
                 chiy = 1 - FNCut(parameter_smallchart, parameter_bigchart, -real(y6));  //cut-off
                 chiz = 1 - FNCut(parameter_smallchart, parameter_bigchart, -real(z6));
                 Cof = (1 - chix) * (1 - chiy) * (1- chiz) * FNBigcut2(nx, ny, nz);
                 mass+=Cof * (pow(8.,3.) * combin * combinw) * Wt;
                 compt++;
             }
             while (Cof !=0);
//}
                     
         }
     }
 }
 
}
}
 
 
*/

