/***************************************************************************
 *   Copyright (C) 2006 by Julien Keller                                   *
 *   j.keller@imperial.ac.uk                                               *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/



#include "k3.h"

#define Complex  std::complex<double>
#define _Complex_I std::complex<double>(0, 1)
#define _1  (std::complex<double>(1, 0))
#define _2  (std::complex<double>(2, 0))
#define _3  (std::complex<double>(3, 0))
#define _0  (std::complex<double>(0, 0))
#define PI  3.14159265358979323846

#define pow2(x) (x*x)
#define pow3(x) (x*x*x)
#define pow4(x) pow2(x*x)
#define pow5(x) (x*pow4(x))
#define pow6(x) pow2(pow3(x))
#define pow8(x) pow2(pow4(x))








int main(int argc, char **argv)
{

  double mass=0;
  double vollong;


  int p,q;
  MMatrix<double> Mrecord;
  MMatrix<double> diff;

  initialisation(K,A,B,argc,argv);  /*general variables */
  MMatrix<double> new_A(size_A,size_A);
  MMatrix<double> new_B(size_B,size_B);
  MMatrix<double> new_C_A(C_A.getHeight(),C_A.getWidth());

  MMatrix<double> new_C_B(C_B.getHeight(),C_B.getWidth());
  MMatrix<double> dist(10,1);

  int special=0;
  if(choice==3)
  {
    special=1;
    choice=0;
  }
  A2.resize(size_A,size_A);
  B2.resize(size_B,size_B);
  C_A2.resize(C_A.getHeight(),C_A.getWidth());
  update_new_C_A2.resize(C_A.getHeight(),C_A.getWidth());
  while(itk<=number)
  {
    Euler_density=0;
    if (special==1)
    {

      if (itk==9)
      {

        choice=1;
      }
    }

    firstchart(mass,new_A,new_B,itk,new_C_A,new_C_B,vollong,dist);
    cout << "\n------------------------ \n first chart computed \n------------------------ \n";
    secondchart(mass,new_A,new_B,itk,new_C_A,new_C_B,vollong,dist);

    if(itk==number-1)
    {
      cout << "itk == " << itk;
      show(A2);
      show(B2);
      show(C_A2);
      for(p=0;p<size_A;p++)
      {
        for(q=0;q<size_A;q++)
        {
          A2[p][q]=1/A2[p][q];
          if(p<size_B && q<size_B-p)
          {
            B2[p][q]=1/B2[p][q];
          }
        }

      }
      C_A2[0][0]=1/C_A2[0][0];
    }

    cout <<" second chart computed \n------------------------ \n";

    new_A= 1/2.*(new_A+ transpose(new_A))+transpose2( 1/2.*(new_A+ transpose(new_A)));
    new_B= 1/2.*(new_B+transpose(new_B))+transpose2(1/2.*(new_B+transpose(new_B)));
    if(itk==0)
    {
      mass = 12 * mass;  // symmetries
    }
    dist=12*(100./mass)*dist;
    fubmass = 3 * fubmass;
    ernorm = 3 * ernorm;
    printf("\nMass : %.3f",mass);
    printf("\nMaximum of eta: %.4f , Minimum of eta: %.4f , Mean value of |eta-1|: %.4f % \n",maxval / VOL, minval / VOL, 100. * ernorm / fubmass);

    if (choice==1)
    {
      show(dist,"Distance");
      data_inversion2(new_A,new_B,new_C_A,new_C_B);
    }
    if ((choice==0 && itk!=number))
    {
      data_inversion(new_A,new_B,new_C_A,new_C_B);
    }
    if (choice==2)
    {
      show(dist,"Distance");
      data_inversion3(new_A,new_B,new_C_A,new_C_B);
    }

    if (choice!=0 || (choice==0 && itk!=number))
    {
      double normalisation=pow(3.,K)/A.sum();
      A=normalisation*A;
      B=normalisation*B;
      C_B=C_B*normalisation;C_A=C_A*normalisation;
      printf("\nMatrices A && B && C\n");
      show(A,"A");
      show(B,"B");
      show(C_A,"C_A");
      // show(C_A2,"C_A2");
      show(C_B,"C_B");
      if(choice==0)
      {
        compute_distance(itk,Mrecord,diff);
      }
      reinitialise(new_A);
      reinitialise(new_B);
      reinitialise(new_C_A);
      reinitialise(dist);
      reinitialise(new_C_B);
      fubmass=0;ernorm=0;
      maxval = 5.404;
      minval = 5.404;
    }
    itk++;


  }
  seconds=time (NULL)-seconds;
  cout << "\n \n-- Time of computation : " << seconds <<" sec " <<endl;
  if (write_results==1)
  {
    write_results_in_file(mass);
  }
}








double FNBigcut(double ax,double ay)
{
  double Bz,Bx,By;

  Bz = (1 - FNCut(parameter1_FNcut, parameter2_FNcut, ax)) * (1 - FNCut(parameter1_FNcut,parameter2_FNcut, ay));
  Bx= (ax > 0)? (1 - FNCut(parameter1_FNcut,parameter2_FNcut, 1 / ax)) * (1 - FNCut(parameter1_FNcut, parameter2_FNcut, ay / ax)):0;
  By= (ay > 0)? (1 - FNCut(parameter1_FNcut, parameter2_FNcut, 1 / ay)) * (1 - FNCut(parameter1_FNcut, parameter2_FNcut, ax / ay)):0;
  return(Bz / (Bx + By + Bz));
}




double FNCut (double a,double b,double x)
{
  if(x < a)
  {
    return(0);
  }
  if(x > b)
  {
    return(1);
  }
  if(x >= a && x <= b)
  {
    return(.5 * (1 - cos((x - a) / (b - a) * PI)));
  }
}







void summand(double nw,double nx,double ny,Complex x6, Complex y6,MMatrix<double>& new_A,MMatrix<double>& new_B,MMatrix<double>&  new_C_A,MMatrix <double>& new_C_B,double delmass,double defect)
{

  int q,p,i,l;
  double pnx,pny,x6r,x6i,y6i,y6r;
  double denom,cross,uT;
  double rt3,rtt3;
  double delmass_choice=(choice==1 || choice==2 ||itk==number)?delmass*defect:delmass;
  denom= 0;
  y6r=real(y6);
  y6i=imag(y6);
  x6r=real(x6);
  x6i=imag(x6);
  cross=real(x6* conj(y6));
  uT = x6r + cross + y6r;


  pnx=1;
  pny=1;
  double sum;
  for(p = 0;p<size_A;p++)
  {
    sum=0;
    for(q=0;q<size_A-p; q++)
    {
      sum+=  ((p<size_B && q<size_B-p)?(A[p][q]+pow2(nw)*B[p][q])*pny:A[p][q]*pny);
      pny*= pow2(ny);
    }
    pny=1;
    denom+=pnx*sum;
    pnx*= pow2(nx);

  }

  {
    for(i=0;i<Inverseterms_C_A.getHeight();i++)
    {
      l=Inverseterms_C_A[i][0];
      update_new_C_A[l][0]=(pow(nx,2.*Matrices_Inverseterms_A[i][1])*pow(ny,2.*Matrices_Inverseterms_A[i][0])+pow(nx,2.*Matrices_Inverseterms_A[i][3])*pow(ny,2.*Matrices_Inverseterms_A[i][2])     )*x6r+(pow(ny,2.*Matrices_Inverseterms_A[i][2])*pow(nx,2.*Matrices_Inverseterms_A[i][3])+
                           pow(ny,2.*Matrices_Inverseterms_A[i][0])*pow(nx,2.*Matrices_Inverseterms_A[i][1]))*y6r
                           +cross*(pow(nx,2.*Matrices_Inverseterms_A[i][4])*pow(ny,2.*Matrices_Inverseterms_A[i][5])+pow(ny,2.*Matrices_Inverseterms_A[i][4])*pow(nx,2.*Matrices_Inverseterms_A[i][5]));

      if (Inverseterms_C_A[i][1]!=l)
      {
        l=Inverseterms_C_A[i][1];
        update_new_C_A[l][0]=(pow(nx,2.*Matrices_Inverseterms_A[i][1])*pow(ny,2.*Matrices_Inverseterms_A[i][0])+pow(nx,2.*Matrices_Inverseterms_A[i][5])*pow(ny,2.*Matrices_Inverseterms_A[i][4])     )*x6r+(pow(nx,2.*Matrices_Inverseterms_A[i][4])*pow(ny,2.*Matrices_Inverseterms_A[i][5])+
                             pow(nx,2.*Matrices_Inverseterms_A[i][0])*pow(ny,2.*Matrices_Inverseterms_A[i][1]))*y6r
                             +cross*(pow(nx,2.*Matrices_Inverseterms_A[i][2])*pow(ny,2.*Matrices_Inverseterms_A[i][3])+pow(nx,2.*Matrices_Inverseterms_A[i][3])*pow(ny,2.*Matrices_Inverseterms_A[i][2]));
      }
      if ((Inverseterms_C_A[i][2]!=Inverseterms_C_A[i][1]) && (Inverseterms_C_A[i][2]!=Inverseterms_C_A[i][0]))
      {
        l=Inverseterms_C_A[i][2];
        update_new_C_A[l][0]=(pow(nx,2.*Matrices_Inverseterms_A[i][5])*pow(ny,2.*Matrices_Inverseterms_A[i][4])+pow(nx,2.*Matrices_Inverseterms_A[i][3])*pow(ny,2.*Matrices_Inverseterms_A[i][2])     )*x6r+(pow(nx,2.*Matrices_Inverseterms_A[i][2])*pow(ny,2.*Matrices_Inverseterms_A[i][3])+
                             pow(nx,2.*Matrices_Inverseterms_A[i][4])*pow(ny,2.*Matrices_Inverseterms_A[i][5]))*y6r
                             +cross*(pow(nx,2.*Matrices_Inverseterms_A[i][0])*pow(ny,2.*Matrices_Inverseterms_A[i][1])+pow(ny,2.*Matrices_Inverseterms_A[i][0])*pow(nx,2.*Matrices_Inverseterms_A[i][1]));
      }

    }
    for(i=0;i<Inverseterms_C_B.getHeight();i++)
    {
      l=Inverseterms_C_B[i][0];
      update_new_C_B[l][0]=(pow(nx,2.*Matrices_Inverseterms_B[i][1])*pow(ny,2.*Matrices_Inverseterms_B[i][0])+pow(nx,2.*Matrices_Inverseterms_B[i][3])*pow(ny,2.*Matrices_Inverseterms_B[i][2])     )*x6r+(pow(ny,2.*Matrices_Inverseterms_B[i][2])*pow(nx,2.*Matrices_Inverseterms_B[i][3])+
                           pow(ny,2.*Matrices_Inverseterms_B[i][0])*pow(nx,2.*Matrices_Inverseterms_B[i][1]))*y6r
                           +cross*(pow(nx,2.*Matrices_Inverseterms_B[i][4])*pow(ny,2.*Matrices_Inverseterms_B[i][5])+pow(ny,2.*Matrices_Inverseterms_B[i][4])*pow(nx,2.*Matrices_Inverseterms_B[i][5]));

      if (Inverseterms_C_B[i][1]!=l)
      {
        l=Inverseterms_C_B[i][1];
        update_new_C_B[l][0]=(pow(nx,2.*Matrices_Inverseterms_B[i][1])*pow(ny,2.*Matrices_Inverseterms_B[i][0])+pow(nx,2.*Matrices_Inverseterms_B[i][5])*pow(ny,2.*Matrices_Inverseterms_B[i][4])     )*x6r+(pow(nx,2.*Matrices_Inverseterms_B[i][4])*pow(ny,2.*Matrices_Inverseterms_B[i][5])+
                             pow(nx,2.*Matrices_Inverseterms_B[i][0])*pow(ny,2.*Matrices_Inverseterms_B[i][1]))*y6r
                             +cross*(pow(nx,2.*Matrices_Inverseterms_B[i][2])*pow(ny,2.*Matrices_Inverseterms_B[i][3])+pow(nx,2.*Matrices_Inverseterms_B[i][3])*pow(ny,2.*Matrices_Inverseterms_B[i][2]));

      }
      if ((Inverseterms_C_B[i][2]!=Inverseterms_C_B[i][1]) && (Inverseterms_C_B[i][2]!=Inverseterms_C_B[i][0]))
      {
        l=Inverseterms_C_B[i][2];
        update_new_C_B[l][0]=(pow(nx,2.*Matrices_Inverseterms_B[i][5])*pow(ny,2.*Matrices_Inverseterms_B[i][4])+pow(nx,2.*Matrices_Inverseterms_B[i][3])*pow(ny,2.*Matrices_Inverseterms_B[i][2])     )*x6r+(pow(nx,2.*Matrices_Inverseterms_B[i][2])*pow(ny,2.*Matrices_Inverseterms_B[i][3])+
                             pow(nx,2.*Matrices_Inverseterms_B[i][4])*pow(ny,2.*Matrices_Inverseterms_B[i][5]))*y6r
                             +cross*(pow(nx,2.*Matrices_Inverseterms_B[i][0])*pow(ny,2.*Matrices_Inverseterms_B[i][1])+pow(ny,2.*Matrices_Inverseterms_B[i][0])*pow(nx,2.*Matrices_Inverseterms_B[i][1]));

      }

    }

    update_new_C_B=pow2(nw)*update_new_C_B;
  }
  denom+=2*scalar_product(C_A,update_new_C_A)+2*scalar_product(C_B,update_new_C_B);

  update_new_C_A=(0.5/denom)*update_new_C_A;
  update_new_C_B=(0.5/denom)*update_new_C_B;

  pnx=1;
  pny=1;
  for(p = 0;p<size_A;p++)
  {
    for(q = 0; q<size_A- p;q++)
    {
      new_A[p][q] +=delmass_choice* pnx * pny/ denom;
      if(p<size_B && q<size_B-p)
      {
        new_B[p][q] +=  delmass_choice* pow2(nw) * pnx * pny/ denom;
      }
      pny*=pow2(ny);
    }
    pny=1;
    pnx*=pow2(nx);
  }

  new_C_A+=(delmass_choice)*update_new_C_A;
  new_C_B+=(delmass_choice)*update_new_C_B;
  Euler_density_Temp=denom;
}




/*************************************************************/
/*********************  second CHART *************************/  
/*************************************************************/
//The smaller chart
void secondchart(double &mass,MMatrix<double> &new_A, MMatrix<double> &new_B,int itk,MMatrix<double> &new_C_A,MMatrix<double> &new_C_B,double &vollong,MMatrix<double> &dist)
{


  double defect;  //d\mu_{G_0}/\nu -1
  double delmass;  // dirac mass
  double band;
  int i,j,k,l,m,combin;
  Complex v,ZA,w,x,x6,y6;
  double alpha,hbot,lbot,lbot_sign,combinw,Wt,Cof,chix,chiy,nw,nx,ny;
  double hmax,hmaxint;

  int p,q;
  double pnx,pny,x6r,y6r;
  Complex cross;

  for(i=0;i<(Numv / 2.) +1;i++)
  {
    if(pow2(i * rad / Numv) <= rad / 2.)
    {
      hmax= rad/2. + sqrt(pow2(rad / 2.)-pow2(i * rad / Numv));
      hmaxint = ((hmax / rad)*Numv) + 1;
    }
    for(j=0;j<hmaxint+1;j++)
    {
      Complex v=Complex (i*rad/Numv,(j * rad) / Numv);
      (i==0) ? (combin=(j==0)? 1:2) : (combin=(j==0)? 2:4) ;
      ZA=Complex(0.5,0)*(Complex((1 - 2 * parameter_smallchart),rad) - v);
      alpha = (real(ZA)+ abs(ZA) < 0)? 0 : sqrt(real(ZA) + abs(ZA));
      for(k = 0;k<(alpha * Numw)+2;k++)
      {
        hbot = (pow2(k/Numw) <= 2 * real(ZA)) ? 0 : sqrt(pow2(k/Numw) - 2. * real(ZA));
        lbot = floor(hbot * Numw);
        for(m= 0;m<2;m++)
        {
          lbot_sign = ((m==0)?1:-1) * lbot -  ((m==0)?1:-1) ;
          l = 0;
          do
          {
            l = l + 1;
            lbot_sign = lbot_sign +  (-2*m+1) ;
            combinw = 2;
            (k==0)? (combinw=(lbot_sign!=0)? 1:0.5) : (combinw=(lbot_sign==0)? 1:2);
            w=Complex(k/Numw ,lbot_sign/Numw);
            x= pow((Complex (0.5,0)) * (pow2(w)+v-_1),Complex (1/6.,0));
            nx =abs(x);
            ny =pow(0.5* abs(pow2(w)-v-_1),1/6.);
            Wt =(nx*ny==0)?0:pow2(rad)/(pow2(36. * pow5(nx*ny) * Numv*Numw)); //holomorph form
            x6 = 0.5* (pow2(w) + v - _1);
            y6 = 0.5* (pow2(w) - v - _1);
            chix = 1 - FNCut(parameter_smallchart, parameter_bigchart, -real(x6));
            chiy = 1 - FNCut(parameter_smallchart, parameter_bigchart, -real(y6));  //cut-off
            Cof = (1 - chix) * (1 - chiy) * FNBigcut(nx, ny);
            delmass=Cof * (36. * combin * combinw) * Wt;

            if(itk==0)
            {
              mass += delmass;
            }
            nw = abs(w);
            if (choice==0 && Cof>0 && itk<number)
            {
              summand(nw,nx,ny,x6,y6,new_A,new_B,new_C_A,new_C_B,delmass,defect);

            }

            if (((choice==1 || choice==2) && Cof>0) || ((Cof>0) && itk==number))
            {
              if(nw>0.5 && nw<1.5)
              {
                if(method_compute_vol==1||method_compute_vol==3)
                {
                  compute_volume(B,A,C_B,C_A,x,pow(y6,Complex(1./6.,0)),nw,vollong,Z,Deriv_x,Deriv_y);
                }
                if(method_compute_vol==2)
                {
                  compute_volume2(B,A,C_B,C_A,x,pow(y6,Complex(1./6.,0)),nw,vollong,Z,Deriv_x,Deriv_y,Zw,Deriv_xw,Deriv_yw,Cof) ;
                }
              }
              defect=vollong-VOL;
              summand(nw,nx,ny,x6,y6,new_A,new_B,new_C_A,new_C_B,delmass,defect);
              fubmass = fubmass + delmass * vollong;
              ernorm = ernorm + delmass *fabs(defect);
              maxval=max(maxval,vollong);
              minval=min(minval,vollong);
              band = (defect/VOL>=lowbound)? floor((defect/VOL-lowbound)/distspace) + 1 :0;
              band= min(band,9.);
              dist[(int) band][0] = dist[(int) band][0] + delmass;
            }
            if(itk==number-1)
            {
              //show(A2);
              pnx=1;
              pny=1;
              for(p = 0;p<size_A;p++)
              {
                for(q=0;q<size_A-p; q++)
                {
                  A2[p][q]+=pnx*pny*(Euler_density_Temp)*delmass;
                  if(p<size_B && q<size_B-p)
                  {
                    B2[p][q]+=pow2(nw)*pnx*pny*(Euler_density_Temp)*delmass;
                  }
                  pny*= pow2(ny);
                }
                pny=1;
                pnx*= pow2(nx);

              }
              x6r=real(x6);
              cross=real(x6* conj(y6));
              y6r=real(y6);
              C_A2[0][0]+=abs((pow(nx,2.*Matrices_Inverseterms_A[0][1])*pow(ny,2.*Matrices_Inverseterms_A[0][0])+pow(nx,2.*Matrices_Inverseterms_A[0][3])*pow(ny,2.*Matrices_Inverseterms_A[0][2])     )*x6r+(pow(ny,2.*Matrices_Inverseterms_A[0][2])*pow(nx,2.*Matrices_Inverseterms_A[0][3])+
                              pow(ny,2.*Matrices_Inverseterms_A[0][0])*pow(nx,2.*Matrices_Inverseterms_A[0][1]))*y6r
                              +cross*(pow(nx,2.*Matrices_Inverseterms_A[0][4])*pow(ny,2.*Matrices_Inverseterms_A[0][5])+pow(ny,2.*Matrices_Inverseterms_A[0][4])*pow(nx,2.*Matrices_Inverseterms_A[0][5]))*Complex (pnx*pny*(Euler_density_Temp)*delmass,0));
            }
            Euler_density+=pow2(rad) *Cof * (36. * combin * combinw) * (Euler_density_Temp-pow2(K))/(pow2(Numv*Numw));

          }
          while (Cof !=0 || ! (l> (0.2*Numw) || Cof>0));
        }
      }
    }
  }

}







/*************************************************************/
/********************* first CHART ***************************/
/*************************************************************/
void firstchart(double &mass,MMatrix<double> &new_A, MMatrix<double> &new_B,int itk, MMatrix<double> &new_C_A,MMatrix<double> &new_C_B,double &vollong,MMatrix<double> &dist)
{

  double defect;
  int i,j,k,l,combinx,combinp;
  Complex x,x6,p6,y6,p;
  double S_x,delmass,band;
  double nx,chix,chiy,p6r,ny,nw,Wt,Cof,norm,chiconj;


  int q1,q;
  double pnx,pny,x6r,y6r;
  Complex cross;

  for(i = 0;i<Numx+1;i++)
  {
    j = -1;
    do
    {

      j = j + 1;

      combinx=(i==0 && j==0)?1:((i==0 && j>0)?0:6);
      x=Complex(i*radius2/Numx+.5 *j*radius2/Numx, ((sqrt(3.)/2.)*j*radius2 / Numx));
      nx = abs(x);
      x6=pow6(x);
      chix = 1 - FNCut(parameter_smallchart, parameter_bigchart, -real(x6));
      for(k=0;k<Nump+1;k++)
      {
        l = -1;
        do
        {
          l = l + 1;
          p=Complex(radius2 * ((k / Nump) + l * (.5 / Nump)), (radius2 * (l / Nump) * sqrt(3.) / 2));
          (k==0)? (combinp=(l==0)? 1:3) : (combinp=(l==0)? 3:6);
          p6=pow6(p);
          S_x=abs(_1+x6);
          ny=pow( S_x,1/6.)*abs(p)*pow(abs(_2+p6),1/6.);
          nw =  abs(_1+p6)* sqrt(S_x);
          y6=((p6+_2)*p6)*(_1+x6);
          chiy = 1 - FNCut(parameter_smallchart, parameter_bigchart, -real(y6));
          Wt=(S_x*abs(_2+p6)==0)?0:pow4(radius2)*3.*pow(S_x,-2/3.)*pow(abs(_2+p6),-5/3.)/(pow2(Nump*Numx));
          norm= -.5 * real(p) +sqrt(3.) * (.5) * imag(p);
          chiconj = 1 - FNCut(-parameter3_FNcut,parameter3_FNcut, norm);
          Cof = FNBigcut(nx, ny) * FNCut(-.5, .5, real(p6) + 1) * chix * (2 - chiy) * chiconj;
          delmass= Wt * Cof * (4. * combinp * combinx);
          if(itk==0)
          {
            mass = mass + delmass;
          }
          if (choice==0 && Cof>0 && itk<number)
          {
            summand(nw,nx,ny,x6,y6,new_A,new_B,new_C_A,new_C_B,delmass,defect);

          }
          if ((choice==1 || choice==2) && Cof>0 || ((Cof>0) && itk==number))
          {
            if(nw>0.5 && nw<1.5)
            {
              if(method_compute_vol==1 || method_compute_vol==3)
              {
                compute_volume(B,A,C_B,C_A,x,pow(y6,Complex(1/6.,0)),nw,vollong,Z,Deriv_x,Deriv_y);
              }
              if(method_compute_vol==3)
              {
                compute_volume2(B,A,C_B,C_A,x,pow(y6,Complex (1/6.,0)),nw,vollong,Z,Deriv_x,Deriv_y,Zw,Deriv_xw,Deriv_yw,Cof);
              }
            }


            defect=vollong-VOL;
            summand(nw,nx,ny,x6,y6,new_A,new_B,new_C_A,new_C_B,delmass,defect);
            fubmass += delmass * vollong;
            ernorm += delmass *fabs(defect);
            maxval=max(maxval,vollong);
            minval=min(minval,vollong);
            band = (defect/VOL>=lowbound)? floor((defect/VOL-lowbound)/distspace) + 1 :0;
            band= min(band,9.);
            dist[(int) band][0] = dist[(int) band][0] + delmass;




          }

          if(itk==number-1)
          {
            x6r=real(x6);
            cross=real(x6* conj(y6));
            y6r=real(y6);
            pnx=1;
            pny=1;
            for(q1 = 0;q1<size_A;q1++)
            {
              for(q=0;q<size_A-q1;q++)
              {
                A2[q1][q]+=pnx*pny*(Euler_density_Temp)*delmass;
                if(q1<size_B && q<size_B-q1)
                {
                  B2[q1][q]+=pow2(nw)*pnx*pny*(Euler_density_Temp)*delmass;
                }
                pny*= pow2(ny);
              }
              pny=1;
              pnx*= pow2(nx);

            }
            C_A2[0][0]+=abs((pow(nx,2.*Matrices_Inverseterms_A[0][1])*pow(ny,2.*Matrices_Inverseterms_A[0][0])+pow(nx,2.*Matrices_Inverseterms_A[0][3])*pow(ny,2.*Matrices_Inverseterms_A[0][2])     )*x6r+(pow(ny,2.*Matrices_Inverseterms_A[0][2])*pow(nx,2.*Matrices_Inverseterms_A[0][3])+
                            pow(ny,2.*Matrices_Inverseterms_A[0][0])*pow(nx,2.*Matrices_Inverseterms_A[0][1]))*y6r
                            +cross*(pow(nx,2.*Matrices_Inverseterms_A[0][4])*pow(ny,2.*Matrices_Inverseterms_A[0][5])+pow(ny,2.*Matrices_Inverseterms_A[0][4])*pow(nx,2.*Matrices_Inverseterms_A[0][5]))*Complex (pnx*pny*(Euler_density_Temp)*delmass));
          }
          Euler_density+=pow4(radius2) *Cof * (3. * combinp * combinx) * (Euler_density_Temp -pow2(K))/(pow2(Nump*Numx));



        }
        while(abs(p) < pow(2.,1/6.)*(1.2)*pow(S_x,-1/6.) && l!= Nump-k && real(p6)>= -1.5 && chiconj != 0);
      }

    }
    while(chix != 0 && nx <= 1.2);
  }
}













void compute_distance(int itk,MMatrix<double> &Mrecord,MMatrix<double> &diff)
{


  int i,j,size;
  if(itk==0)
  {
    Mrecord.resize(2,Diagonalterms_A.getHeight()+Diagonalterms_B.getHeight()+C_B.getHeight()+C_A.getHeight());
    diff.resize(2,Mrecord.getWidth());

  }
  double eval[Mrecord.getWidth()+1];
  for(j=0;j<Diagonalterms_A.getHeight();j++)
  {
    Mrecord[0][j]=A[Diagonalterms_A[j][0]][Diagonalterms_A[j][1]];
  }
  size=Diagonalterms_A.getHeight();
  for(j=0;j<Diagonalterms_B.getHeight();j++)
  {
    Mrecord[0][size+j]=B[Diagonalterms_B[j][0]][Diagonalterms_B[j][1]];
  }
  size+=Diagonalterms_B.getHeight();
  Mrecord.fillWith(0,size,transpose(C_B),0,0);
  Mrecord.fillWith(0,size+C_B.getHeight(),transpose(C_A),0,0);
  double norm2;
  for(i = 0;i<Mrecord.getWidth();i++)
  {

    if(itk >= 1)
    {
      diff[0][i] = Mrecord[0][i]- Mrecord[1][i];
      if (itk>=2 && diff[1][i]!=0)
      {
        eval[i] = diff[0][i] /diff[1][i] ;
      }
      else
      {
        eval[i] = diff[0][i];
      }
    }
    else
    {
      diff[0][i] = 1;
      eval[i] = diff[0][i];
    }
  }
  norm2=diff.subMMatrix(0,0,1,diff.getWidth()).norm2();
  Mrecord.shift(1,0);
  if (itk==number-1)
  {
    for(i = 0;i<diff.getWidth();i++)
    {
      printf("\n Distance %.3f -- %+.3f  for  ", eval[i], diff[0][i] / norm2 );
      if (i< Diagonalterms_A.getHeight())
      {
        printf("A[%d][%d] ",Diagonalterms_A[i][0],Diagonalterms_A[i][1]);
      }
      if((i>= Diagonalterms_A.getHeight()) && i<Diagonalterms_A.getHeight()+Diagonalterms_B.getHeight())
      {
        printf("B[%d][%d] ",Diagonalterms_B[i- Diagonalterms_A.getHeight()][0],Diagonalterms_B[i- Diagonalterms_A.getHeight()][1]);
      }
      if((i>= Diagonalterms_A.getHeight()+ Diagonalterms_B.getHeight()) &&
          (i<Diagonalterms_A.getHeight()+ Diagonalterms_B.getHeight()+C_B.getHeight()))
      {
        printf("C_B[%d] ",i- Diagonalterms_A.getHeight()- Diagonalterms_B.getHeight());
      }
      if((i>= Diagonalterms_A.getHeight()+ Diagonalterms_B.getHeight()+C_B.getHeight()) &&
          (i<Diagonalterms_A.getHeight()+ Diagonalterms_B.getHeight()+C_B.getHeight())+C_A.getHeight())
      {
        printf("C_A[%d] ",i- Diagonalterms_A.getHeight()- Diagonalterms_B.getHeight()-C_B.getHeight());
      }
    }
  }
  diff.shift(1,0);
}





void skipline(ifstream & mystream)
{
  mystream.ignore(100,'\n');
}






void initialisation(int k,MMatrix<double> &A,MMatrix<double> &B,int argc,char** argv)
{
  double val_12,val_11,val_10,val_9,val_8,val_7,val_6,val_5,val_4,val_3,val_2,val_1,bval_7,bval_6,bval_5,bval_4,bval_3,bval_2,bval_1;
  int p,q,i;
  int matrices_read=0;

  ifstream param("param") ;
  if(argc==2)
  {
    param.close() ;
    param.open(argv[1],ios::in);
  }
  if(!param.is_open())
  {
    cout << "No input parameter file found \n Using standard values" << endl;
    create_matrices(K);
    printf("\nData : %d %f %f %f",choice,speed,distspace,numbdown);
  }
  else
  {
    cout << "Reading input parameters from ";
    if(argc==1)
    {
      cout << "default file" <<endl;
    }
    else
    {
      cout << "file " << argv[1] << endl ;
    }
    param >> choice ;
    skipline(param);
    param >> K ;
    skipline(param);
    param >> number;
    skipline(param);
    param >> Numx;
    param >> Nump;
    param >> Numv;
    param >> Numw;
    skipline(param);
    param >> speed;
    skipline(param);
    param >> distspace;
    skipline(param);
    param >> numbdown;
    skipline(param);
    param >> write_results;
    skipline(param);
    param >> random_matrices;
    skipline(param);
    if (random_matrices==0)
    {
      create_matrices(K);

      A.readFromStream(param);
      B.readFromStream(param);
      C_A.readFromStream(param);
      C_B.readFromStream(param);
      matrices_read=1;
    }
    param.close() ;
  }
  if(matrices_read==0)
  {
    create_matrices(K);
  }
  printf("\nData> Choice of method:%d  K:%d  Speed:%.2f  Distspace:%.2f  Numbdown:%.2f \n  Number of iterations: %d |Charts: %.3f %.3f %.3f %.3f \n", choice,K,speed,distspace,numbdown,number,Numx,Nump,Numv,Numw);
  seconds = time (NULL);
  if(random_matrices==1)
  {
    srand(time(NULL));
    for(i=0;i<Diagonalterms_A.getHeight();i++)
    {
      A[Diagonalterms_A[i][0]][Diagonalterms_A[i][1]]=rand() % MAX_RANDOM;
    }
    for(i=0;i<Diagonalterms_B.getHeight();i++)
    {
      B[Diagonalterms_B[i][0]][Diagonalterms_B[i][1]]=rand() % MAX_RANDOM;
    }
    symmetry(A);
    symmetry(B);
    for(i=0;i<C_A.getHeight();i++)
    {
      C_A[i][0]=rand() % MAX_RANDOM;
    }
    for(i=0;i<C_B.getHeight();i++)
    {
      C_B[i][0]=rand() % MAX_RANDOM;
    }
  }


  show(A,"Data at Start - Matrix A");
  show(B,"Data at Start - Matrix B");
  show(C_A,"Data at Start - Matrix C_A");
  
  if (C_B.getHeight()>0)
  {
    show(C_B,"Data at Start - Matrix C_B");
  }
  fubmass=0;   ernorm=0;
  maxval = VOL;   minval = VOL;
  if (write_results==1)
  {
    bool possible=0;
    int numb=0;
    while(possible==0)
    {
      std::ostringstream s2;
      s2 << "res" << numb <<".txt";
      name_file=s2.str();
      ifstream file(name_file.c_str());
      if(file==NULL)
      {
        possible=1;
        ofstream file(name_file.c_str());
        file << "Data at Start up" << endl;
        file << "Matrix A\n" << A << endl ;
        file << "Matrix B\n" << B << endl;
        file << "Matrix C_A\n" << C_A << endl;
        file << "Matrix C_B\n" << C_B << endl;
        file.close();
      }
      else numb++;
    }
  }
}







void data_inversion3(MMatrix<double>& new_A,MMatrix<double>& new_B,MMatrix<double>& new_C_A,MMatrix <double>&new_C_B)
{
  int p,q,i;
  MMatrix<double> Alpha(3,3);
  MMatrix<double> Epsilon(3,3);
  MMatrix<double> Res(3,3);
  int couple[2];

  if(K==9)
  {
    speed=1;
    for(i=0;i<Diagonalterms_A.getHeight();i++)
    {

      couple[0]=Diagonalterms_A[i][0];
      couple[1]=Diagonalterms_A[i][1];
      if (!present(couple,Matrices_Inverseterms_A))
      {
        
        A[Diagonalterms_A[i][0]][Diagonalterms_A[i][1]]=
          1./(1./A[Diagonalterms_A[i][0]][Diagonalterms_A[i][1]] - speed *new_A[Diagonalterms_A[i][0]][Diagonalterms_A[i][1]]);

      }
    }
    for(i=0;i<Diagonalterms_B.getHeight();i++)
    {
      couple[0]=Diagonalterms_B[i][0];
      couple[1]=Diagonalterms_B[i][1];
      if (!present(couple,Matrices_Inverseterms_B))
      {
        
        B[Diagonalterms_B[i][0]][Diagonalterms_B[i][1]]=
          1./(1./B[Diagonalterms_B[i][0]][Diagonalterms_B[i][1]] - speed *new_B[Diagonalterms_B[i][0]][Diagonalterms_B[i][1]]);
      }
    }


    // Finding the best kappa constant //

    for(p=0;p<Matrices_Inverseterms_A.getHeight();p++)
    {

      Alpha[0][0]=A[Matrices_Inverseterms_A[p][0]][Matrices_Inverseterms_A[p][1]]/2.;
      Alpha[1][1]=A[Matrices_Inverseterms_A[p][2]][Matrices_Inverseterms_A[p][3]]/2.;
      Alpha[2][2]=A[Matrices_Inverseterms_A[p][4]][Matrices_Inverseterms_A[p][5]]/2.;
      Epsilon[0][0]=new_A[Matrices_Inverseterms_A[p][0]][Matrices_Inverseterms_A[p][1]]/2.;
      Epsilon[1][1]=new_A[Matrices_Inverseterms_A[p][2]][Matrices_Inverseterms_A[p][3]]/2.;
      Epsilon[2][2]=new_A[Matrices_Inverseterms_A[p][4]][Matrices_Inverseterms_A[p][5]]/2.;
      Alpha[0][1]=C_A[Inverseterms_C_A[p][0]][0];
      Alpha[0][2]=C_A[Inverseterms_C_A[p][1]][0];
      Alpha[1][2]=C_A[Inverseterms_C_A[p][2]][0];
      Epsilon[0][1]=new_C_A[Inverseterms_C_A[p][0]][0];
      Epsilon[0][2]=new_C_A[Inverseterms_C_A[p][1]][0];
      Epsilon[1][2]=new_C_A[Inverseterms_C_A[p][2]][0];
      Alpha=Alpha+transpose(Alpha);
      Epsilon=Epsilon+transpose(Epsilon);
      Res=inverse(inverse(Alpha)-speed*Epsilon);
      A[Matrices_Inverseterms_A[p][0]][Matrices_Inverseterms_A[p][1]]=Res[0][0];
      if (!(Matrices_Inverseterms_A[p][2]==Matrices_Inverseterms_A[p][0] &&
            Matrices_Inverseterms_A[p][3]==Matrices_Inverseterms_A[p][1]))
      {
        A[Matrices_Inverseterms_A[p][2]][Matrices_Inverseterms_A[p][3]]=Res[1][1];
      }
      if (!((Matrices_Inverseterms_A[p][4]==Matrices_Inverseterms_A[p][0] &&
             Matrices_Inverseterms_A[p][5]==Matrices_Inverseterms_A[p][1])
            || (Matrices_Inverseterms_A[p][4]==Matrices_Inverseterms_A[p][2] &&
                Matrices_Inverseterms_A[p][5]==Matrices_Inverseterms_A[p][3] )))
      {
        A[Matrices_Inverseterms_A[p][4]][Matrices_Inverseterms_A[p][5]]=Res[2][2];
      }
      C_A[Inverseterms_C_A[p][0]][0]=Res[0][1]*speed;
      if (!(Inverseterms_C_A[p][1]==Inverseterms_C_A[p][0]))
      {
        C_A[Inverseterms_C_A[p][1]][0]=Res[0][2];
      }
      if (!((Inverseterms_C_A[p][2]==Inverseterms_C_A[p][1]) ||(Inverseterms_C_A[p][2]==Inverseterms_C_A[p][0])))
      {
        C_A[Inverseterms_C_A[p][2]][0]=Res[1][2];
      }
      reinitialise(Alpha);reinitialise(Epsilon);
    }
    for(p=0;p<Matrices_Inverseterms_B.getHeight();p++)
    {

      Alpha[0][0]=B[Matrices_Inverseterms_B[p][0]][Matrices_Inverseterms_B[p][1]]/2.;
      Alpha[1][1]=B[Matrices_Inverseterms_B[p][2]][Matrices_Inverseterms_B[p][3]]/2.;
      Alpha[2][2]=B[Matrices_Inverseterms_B[p][4]][Matrices_Inverseterms_B[p][5]]/2.;
      Epsilon[0][0]=new_B[Matrices_Inverseterms_B[p][0]][Matrices_Inverseterms_B[p][1]]/2.;
      Epsilon[1][1]=new_B[Matrices_Inverseterms_B[p][2]][Matrices_Inverseterms_B[p][3]]/2.;
      Epsilon[2][2]=new_B[Matrices_Inverseterms_B[p][4]][Matrices_Inverseterms_B[p][5]]/2.;
      Alpha[0][1]=C_B[Inverseterms_C_B[p][0]][0];
      Alpha[0][2]=C_B[Inverseterms_C_B[p][1]][0];
      Alpha[1][2]=C_B[Inverseterms_C_B[p][2]][0];
      Epsilon[0][1]=new_C_B[Inverseterms_C_B[p][0]][0];
      Epsilon[0][2]=new_C_B[Inverseterms_C_B[p][1]][0];
      Epsilon[1][2]=new_C_B[Inverseterms_C_B[p][2]][0];
      Alpha=Alpha+transpose(Alpha);
      Epsilon=Epsilon+transpose(Epsilon);
      Res=inverse(inverse(Alpha)-speed*Epsilon);

      B[Matrices_Inverseterms_B[p][0]][Matrices_Inverseterms_B[p][1]]=Res[0][0];
      if (!(Matrices_Inverseterms_B[p][2]==Matrices_Inverseterms_B[p][0] &&
            Matrices_Inverseterms_B[p][3]==Matrices_Inverseterms_B[p][1]))
      {
        B[Matrices_Inverseterms_B[p][2]][Matrices_Inverseterms_B[p][3]]=Res[1][1];
      }
      if (!((Matrices_Inverseterms_B[p][4]==Matrices_Inverseterms_B[p][0] &&
             Matrices_Inverseterms_B[p][5]==Matrices_Inverseterms_B[p][1])
            || (Matrices_Inverseterms_B[p][4]==Matrices_Inverseterms_B[p][2] &&
                Matrices_Inverseterms_B[p][5]==Matrices_Inverseterms_B[p][3] )))
      {
        B[Matrices_Inverseterms_B[p][4]][Matrices_Inverseterms_B[p][5]]=Res[2][2];
      }
      C_B[Inverseterms_C_B[p][0]][0]=Res[0][1];
      if (!(Inverseterms_C_B[p][1]==Inverseterms_C_B[p][0]))
      {
        C_B[Inverseterms_C_B[p][1]][0]=Res[0][2];
      }
      if (!((Inverseterms_C_B[p][2]==Inverseterms_C_B[p][1]) ||(Inverseterms_C_B[p][2]==Inverseterms_C_B[p][0])))
      {
        C_B[Inverseterms_C_B[p][2]][0]=Res[1][2];
      }
      reinitialise(Alpha);reinitialise(Epsilon);
    }
    symmetry(A);
    symmetry(B);
  }

  if(K==6)
  {
    
    A[2][2] = 1./(1./A[2][2]- speed * new_A[2][2]);
    A[2][1] = 1./(1./A[2][1]- speed * new_A[2][1]);
    A[3][1]=A[2][1];A[3][2]=A[2][1];

    A[1][1]=  1./(1./A[1][1]- speed * new_A[1][1]);
    A[4][1]=A[1][1];

    A[3][0]=  1./(1./A[3][0]- speed * new_A[3][0]);
    A[3][3]=A[3][0];

    A[2][0]=  1./(1./A[2][0]- speed * new_A[2][0]);
    A[4][0]=A[2][0];A[4][2]=A[2][0];

    A[1][0]=  1./(1./A[1][0]- speed * new_A[1][0]);
    A[5][0]=A[1][0];A[5][1]=A[1][0];

    B[1][1]=  1./(1./B[1][1]- speed * new_B[1][1]);
    B[1][0]=  1./(1./B[1][0]- speed * new_B[1][0]);
    B[0][1]=B[1][0];B[0][2]=B[1][0];B[2][0]=B[0][1];B[2][1]=B[1][0];B[1][2]=B[1][0];
    B[0][0]=  1./(1./B[0][0]- speed * new_B[0][0]);
    B[3][0]=B[0][0];B[0][3]=B[0][0];

    Alpha[0][0]=A[0][0]/2.;
    Alpha[1][1]=A[0][0]/2.;
    Alpha[2][2]=A[0][0]/2.;
    Epsilon[0][0]=new_A[0][0]/2.;
    Epsilon[1][1]=new_A[0][0]/2.;
    Epsilon[2][2]=new_A[0][0]/2.;
    Alpha[0][1]=C_A[0][0];
    Alpha[0][2]=C_A[0][0];
    Alpha[1][2]=C_A[0][0];
    Epsilon[0][1]=new_C_A[0][0];
    Epsilon[0][2]=new_C_A[0][0];
    Epsilon[1][2]=new_C_A[0][0];
    Alpha=Alpha+transpose(Alpha);
    Epsilon=Epsilon+transpose(Epsilon);
    speed=min(4./9.,1/spectral_radius(multiply((Alpha),Epsilon)));
    printf("\n speed : %f",speed);
    Res=inverse(inverse(Alpha)-speed*Epsilon);
    A[0][0]=Res[0][0];
    A[6][0]=A[0][0];
    C_A[0][0]=Res[0][1];

    symmetry(A);
    symmetry(B);
  }

}







void data_inversion2(MMatrix<double>& new_A,MMatrix<double>& new_B,MMatrix<double>& new_C_A,MMatrix<double> & new_C_B)
{
  int p,q,i,j,k,l;
  MMatrix<double> Alpha(3,3);
  MMatrix<double> Epsilon(3,3);
  MMatrix<double> Res(3,3);
  MMatrix<int> Coeff(3,2);
  int couple[2];
  if(K>=7)
  {

    for(i=0;i<Diagonalterms_A.getHeight();i++)
    {

      couple[0]=Diagonalterms_A[i][0];
      couple[1]=Diagonalterms_A[i][1];
      if (!present(couple,Matrices_Inverseterms_A))
      {
        
        A[Diagonalterms_A[i][0]][Diagonalterms_A[i][1]]+=speed * new_A[Diagonalterms_A[i][0]][Diagonalterms_A[i][1]]*pow2(A[Diagonalterms_A[i][0]][Diagonalterms_A[i][1]]);
      }
    }
    for(i=0;i<Diagonalterms_B.getHeight();i++)
    {
      couple[0]=Diagonalterms_B[i][0];
      couple[1]=Diagonalterms_B[i][1];
      if (!present(couple,Matrices_Inverseterms_B))
      {
        
        B[Diagonalterms_B[i][0]][Diagonalterms_B[i][1]]+=speed * new_B[Diagonalterms_B[i][0]][Diagonalterms_B[i][1]]*pow2(B[Diagonalterms_B[i][0]][Diagonalterms_B[i][1]]);
      }
    }


    for(p=0;p<Matrices_Inverseterms_A.getHeight();p++)
    {

      Alpha[0][0]=A[Matrices_Inverseterms_A[p][0]][Matrices_Inverseterms_A[p][1]]/2.;
      Alpha[1][1]=A[Matrices_Inverseterms_A[p][2]][Matrices_Inverseterms_A[p][3]]/2.;
      Alpha[2][2]=A[Matrices_Inverseterms_A[p][4]][Matrices_Inverseterms_A[p][5]]/2.;
      Epsilon[0][0]=new_A[Matrices_Inverseterms_A[p][0]][Matrices_Inverseterms_A[p][1]]/2.;
      Epsilon[1][1]=new_A[Matrices_Inverseterms_A[p][2]][Matrices_Inverseterms_A[p][3]]/2.;
      Epsilon[2][2]=new_A[Matrices_Inverseterms_A[p][4]][Matrices_Inverseterms_A[p][5]]/2.;
      Alpha[0][1]=C_A[Inverseterms_C_A[p][0]][0];
      Alpha[0][2]=C_A[Inverseterms_C_A[p][1]][0];
      Alpha[1][2]=C_A[Inverseterms_C_A[p][2]][0];
      Epsilon[0][1]=new_C_A[Inverseterms_C_A[p][0]][0];
      Epsilon[0][2]=new_C_A[Inverseterms_C_A[p][1]][0];
      Epsilon[1][2]=new_C_A[Inverseterms_C_A[p][2]][0];
      Alpha=Alpha+transpose(Alpha);
      Epsilon=Epsilon+transpose(Epsilon);
      Res=multiply(multiply(Alpha,Epsilon),Alpha);
      A[Matrices_Inverseterms_A[p][0]][Matrices_Inverseterms_A[p][1]]+=Res[0][0]*speed;
      if (!(Matrices_Inverseterms_A[p][2]==Matrices_Inverseterms_A[p][0] &&
            Matrices_Inverseterms_A[p][3]==Matrices_Inverseterms_A[p][1]))
      {
        A[Matrices_Inverseterms_A[p][2]][Matrices_Inverseterms_A[p][3]]+=Res[1][1]*speed;
      }
      if (!((Matrices_Inverseterms_A[p][4]==Matrices_Inverseterms_A[p][0] &&
             Matrices_Inverseterms_A[p][5]==Matrices_Inverseterms_A[p][1])
            || (Matrices_Inverseterms_A[p][4]==Matrices_Inverseterms_A[p][2] &&
                Matrices_Inverseterms_A[p][5]==Matrices_Inverseterms_A[p][3] )))
      {
        A[Matrices_Inverseterms_A[p][4]][Matrices_Inverseterms_A[p][5]]+=Res[2][2]*speed;
      }
      C_A[Inverseterms_C_A[p][0]][0]+=Res[0][1]*speed;
      if (!(Inverseterms_C_A[p][1]==Inverseterms_C_A[p][0]))
      {
        C_A[Inverseterms_C_A[p][1]][0]+=Res[0][2]*speed;
      }
      if (!((Inverseterms_C_A[p][2]==Inverseterms_C_A[p][1]) ||(Inverseterms_C_A[p][2]==Inverseterms_C_A[p][0])))
      {
        C_A[Inverseterms_C_A[p][2]][0]+=Res[1][2]*speed;
      }
      reinitialise(Alpha);reinitialise(Epsilon);
    }
    for(p=0;p<Matrices_Inverseterms_B.getHeight();p++)
    {

      Alpha[0][0]=B[Matrices_Inverseterms_B[p][0]][Matrices_Inverseterms_B[p][1]]/2.;
      Alpha[1][1]=B[Matrices_Inverseterms_B[p][2]][Matrices_Inverseterms_B[p][3]]/2.;
      Alpha[2][2]=B[Matrices_Inverseterms_B[p][4]][Matrices_Inverseterms_B[p][5]]/2.;
      Epsilon[0][0]=new_B[Matrices_Inverseterms_B[p][0]][Matrices_Inverseterms_B[p][1]]/2.;
      Epsilon[1][1]=new_B[Matrices_Inverseterms_B[p][2]][Matrices_Inverseterms_B[p][3]]/2.;
      Epsilon[2][2]=new_B[Matrices_Inverseterms_B[p][4]][Matrices_Inverseterms_B[p][5]]/2.;
      Alpha[0][1]=C_B[Inverseterms_C_B[p][0]][0];
      Alpha[0][2]=C_B[Inverseterms_C_B[p][1]][0];
      Alpha[1][2]=C_B[Inverseterms_C_B[p][2]][0];
      Epsilon[0][1]=new_C_B[Inverseterms_C_B[p][0]][0];
      Epsilon[0][2]=new_C_B[Inverseterms_C_B[p][1]][0];
      Epsilon[1][2]=new_C_B[Inverseterms_C_B[p][2]][0];
      Alpha=Alpha+transpose(Alpha);
      Epsilon=Epsilon+transpose(Epsilon);
      Res=multiply(multiply(Alpha,Epsilon),Alpha);
      B[Matrices_Inverseterms_B[p][0]][Matrices_Inverseterms_B[p][1]]+=Res[0][0]*speed;
      if (!(Matrices_Inverseterms_B[p][2]==Matrices_Inverseterms_B[p][0] &&
            Matrices_Inverseterms_B[p][3]==Matrices_Inverseterms_B[p][1]))
      {
        B[Matrices_Inverseterms_B[p][2]][Matrices_Inverseterms_B[p][3]]+=Res[1][1]*speed;
      }
      if (!((Matrices_Inverseterms_B[p][4]==Matrices_Inverseterms_B[p][0] &&
             Matrices_Inverseterms_B[p][5]==Matrices_Inverseterms_B[p][1])
            || (Matrices_Inverseterms_B[p][4]==Matrices_Inverseterms_B[p][2] &&
                Matrices_Inverseterms_B[p][5]==Matrices_Inverseterms_B[p][3] )))
      {
        B[Matrices_Inverseterms_B[p][4]][Matrices_Inverseterms_B[p][5]]+=Res[2][2]*speed;
      }
      C_B[Inverseterms_C_B[p][0]][0]+=Res[0][1]*speed;
      if (!(Inverseterms_C_B[p][1]==Inverseterms_C_B[p][0]))
      {
        C_B[Inverseterms_C_B[p][1]][0]+=Res[0][2]*speed;
      }
      if (!((Inverseterms_C_B[p][2]==Inverseterms_C_B[p][1]) ||(Inverseterms_C_B[p][2]==Inverseterms_C_B[p][0])))
      {
        C_B[Inverseterms_C_B[p][2]][0]+=Res[1][2]*speed;
      }
      reinitialise(Alpha);reinitialise(Epsilon);
    }
    symmetry(A);
    symmetry(B);
  }
  if(K==6)
  {


    A[2][2] = A[2][2]+ speed * new_A[2][2]*pow2(A[2][2]);
    A[2][1] = A[2][1]+ speed * new_A[2][1]*pow2(A[2][1]);
    A[3][1]=A[2][1];A[3][2]=A[2][1];

    A[1][1]=  A[1][1]+ speed * new_A[1][1]*pow2(A[1][1]);
    A[4][1]=A[1][1];

    A[3][0]=  A[3][0]+ speed * new_A[3][0]*pow2(A[3][0]);
    A[3][3]=A[3][0];

    A[2][0]=  A[2][0]+ speed * new_A[2][0]*pow2(A[2][0]);
    A[4][0]=A[2][0];A[4][2]=A[2][0];

    A[1][0]=  A[1][0]+ speed * new_A[1][0]*pow2(A[1][0]);
    A[5][0]=A[1][0];A[5][1]=A[1][0];

    B[1][1]=B[1][1]+ speed*new_B[1][1]*pow2(B[1][1]);
    B[1][0]=B[1][0]+ speed*new_B[1][0]*pow2(B[1][0]);
    B[0][1]=B[1][0];B[0][2]=B[1][0];B[2][0]=B[0][1];B[2][1]=B[1][0];B[1][2]=B[1][0];
    B[0][0]=B[0][0]+ speed*new_B[0][0]*pow2(B[0][0]);
    B[3][0]=B[0][0];B[0][3]=B[0][0];

    Alpha[0][0]=A[0][0]/2.;
    Alpha[1][1]=A[0][0]/2.;
    Alpha[2][2]=A[0][0]/2.;
    Epsilon[0][0]=new_A[0][0]/2.;
    Epsilon[1][1]=new_A[0][0]/2.;
    Epsilon[2][2]=new_A[0][0]/2.;
    Alpha[0][1]=C_A[0][0];
    Alpha[0][2]=C_A[0][0];
    Alpha[1][2]=C_A[0][0];
    Epsilon[0][1]=new_C_A[0][0];
    Epsilon[0][2]=new_C_A[0][0];
    Epsilon[1][2]=new_C_A[0][0];
    Alpha=Alpha+transpose(Alpha);
    Epsilon=Epsilon+transpose(Epsilon);
    Res=multiply(multiply(Alpha,Epsilon),Alpha);
    A[0][0]=A[0][0]+Res[0][0]*speed;
    A[6][0]=A[0][0];
    C_A[0][0]=C_A[0][0]+Res[0][1]*speed;
    symmetry(A);
    symmetry(B);
  }
}




void data_inversion(MMatrix<double>& new_A,MMatrix<double>& new_B,MMatrix<double>& new_C_A,MMatrix<double> & new_C_B)
{
  MMatrix<double> InvTemp(3,3);
  int p,q,i;
  for(i=0;i<Diagonalterms_A.getHeight();i++)
  {
    A[Diagonalterms_A[i][0]][Diagonalterms_A[i][1]]=1/new_A[Diagonalterms_A[i][0]][Diagonalterms_A[i][1]];
  }
  for(i=0;i<Diagonalterms_B.getHeight();i++)
  {
    B[Diagonalterms_B[i][0]][Diagonalterms_B[i][1]]=1/new_B[Diagonalterms_B[i][0]][Diagonalterms_B[i][1]];
  }

  if(K>=7)
  {
    int p;
    for(p=0;p<Matrices_Inverseterms_A.getHeight();p++)
    {
      InvTemp[0][0]=new_A[Matrices_Inverseterms_A[p][0]][Matrices_Inverseterms_A[p][1]]/2.;
      InvTemp[1][1]=new_A[Matrices_Inverseterms_A[p][2]][Matrices_Inverseterms_A[p][3]]/2.;
      InvTemp[2][2]=new_A[Matrices_Inverseterms_A[p][4]][Matrices_Inverseterms_A[p][5]]/2.;
      InvTemp[0][1]=new_C_A[Inverseterms_C_A[p][0]][0];
      InvTemp[0][2]=new_C_A[Inverseterms_C_A[p][1]][0];
      InvTemp[1][2]=new_C_A[Inverseterms_C_A[p][2]][0];
      InvTemp=InvTemp+transpose(InvTemp);
      InvTemp=inverse(InvTemp);
      A[Matrices_Inverseterms_A[p][0]][Matrices_Inverseterms_A[p][1]]=InvTemp[0][0];
      A[Matrices_Inverseterms_A[p][2]][Matrices_Inverseterms_A[p][3]]=InvTemp[1][1];
      A[Matrices_Inverseterms_A[p][4]][Matrices_Inverseterms_A[p][5]]=InvTemp[2][2];
      C_A[Inverseterms_C_A[p][0]][0]=InvTemp[0][1];
      C_A[Inverseterms_C_A[p][1]][0]=InvTemp[0][2];
      C_A[Inverseterms_C_A[p][2]][0]=InvTemp[1][2];

      reinitialise(InvTemp);
    }

    for(p=0;p<Matrices_Inverseterms_B.getHeight();p++)
    {
      InvTemp[0][0]=new_B[Matrices_Inverseterms_B[p][0]][Matrices_Inverseterms_B[p][1]]/2.;
      InvTemp[1][1]=new_B[Matrices_Inverseterms_B[p][2]][Matrices_Inverseterms_B[p][3]]/2.;
      InvTemp[2][2]=new_B[Matrices_Inverseterms_B[p][4]][Matrices_Inverseterms_B[p][5]]/2.;
      InvTemp[0][1]=new_C_B[Inverseterms_C_B[p][0]][0];
      InvTemp[0][2]=new_C_B[Inverseterms_C_B[p][1]][0];
      InvTemp[1][2]=new_C_B[Inverseterms_C_B[p][2]][0];
      InvTemp=InvTemp+transpose(InvTemp);
      InvTemp=inverse(InvTemp);
      B[Matrices_Inverseterms_B[p][0]][Matrices_Inverseterms_B[p][1]]=InvTemp[0][0];
      B[Matrices_Inverseterms_B[p][2]][Matrices_Inverseterms_B[p][3]]=InvTemp[1][1];
      B[Matrices_Inverseterms_B[p][4]][Matrices_Inverseterms_B[p][5]]=InvTemp[2][2];
      C_B[Inverseterms_C_B[p][0]][0]=InvTemp[0][1];
      C_B[Inverseterms_C_B[p][1]][0]=InvTemp[0][2];
      C_B[Inverseterms_C_B[p][2]][0]=InvTemp[1][2];

      reinitialise(InvTemp);
    }


  }

  if (K==6)
  {
    InvTemp[0][0]=new_A[0][0]/2.;
    InvTemp[0][1]=new_C_A[0][0];
    InvTemp[0][2]=new_C_A[0][0];
    InvTemp[1][1]=new_A[0][0]/2.;
    InvTemp[1][2]=new_C_A[0][0];
    InvTemp[2][2]=new_A[0][0]/2.;
    InvTemp=InvTemp+transpose(InvTemp);
    InvTemp=inverse(InvTemp);
    A[0][0]=InvTemp[0][0];
    A[6][0]=InvTemp[0][0];
    C_A[0][0]=InvTemp[0][1];
  }
  symmetry(A);
  symmetry(B);
}






void compute_volume2(MMatrix<double> &B, MMatrix<double> &A,MMatrix<double> &C_B, MMatrix<double> &C_A,Complex x,Complex y,double nw,double &vollong,MMatrix<Complex> &Z,MMatrix<Complex> &Deriv_x,MMatrix<Complex> &Deriv_y,MMatrix<Complex> &Zw,MMatrix<Complex> &Deriv_xw,MMatrix<Complex> &Deriv_yw,double Cof)
{

  if(nw>brep)
  {
    double nx=abs(x);
    double ny=abs(y);

    Complex w=sqrt(pow6(x)+pow6(y)+_1);
    int p,q;
    double pny,ppny;
    double pnx=1;
    double ppnx=1;
    Complex p_x=_1;
    Complex pp_x=1;
    Complex p_y=_1;
    Complex pp_y=1;
    for(p = 0;p<size_A;p++)
    {
      p_y=1;
      for(q = 0;q<size_A-p;q++)
      {

        Z[p][q]=p_x*p_y;

        if(p==1)
        {
          Deriv_x[p][q]=(Complex (p,0))*p_y;
        }
        if(p>1 && x==_0)
        {
          Deriv_x[p][q]=_0;
        }
        if(p>1 && x!=_0)
        {
          Deriv_x[p][q]=(Complex (p,0))*pp_x*p_y;
        }
        if(q==1)
        {
          Deriv_y[p][q]=(Complex (q,0))*p_x;
        }
        if (q>1 && y==_0)
        {
          Deriv_y[p][q]=_0;
        }
        if (q>1 && y!=_0)
        {
          Deriv_y[p][q]=(Complex (q,0))*p_x*pp_y;
        }
        pp_y=p_y;
        p_y*=y;
      }
      pp_x=p_x;
      p_x*=x;
    }
    for(p = 0;p<size_A;p++)
    {
      for(q = 0;q<size_A-p;q++)
      {
        if(p < size_B && q<size_B-p)
        {
          Zw[p][q]= Z[p][q]*w;
        }
      }
    }
    MMatrix<Complex> Temp(3,3);
    MMatrix<Complex> Tempb(3,3);
    Complex res1,res2;
    hermit2(A,B,C_A,C_B,Z,Z,Zw,Zw,res1,res2);
    Temp[0][0]=real(res1+res2);

    Complex x5=Z[5][0];
    Complex y5=Z[0][5];
    for(p = 0;p<size_B;p++)
    {
      for(q = 0;q<size_B-p;q++)
      {

        Deriv_xw[p][q]= pow2(w)*Deriv_x[p][q]+(_3*x5)*Z[p][q];
        Deriv_yw[p][q]= pow2(w)*Deriv_y[p][q]+(_3*y5)*Z[p][q];
      }
    }
    hermit2(A,B,C_A,C_B,Z,Deriv_x,Z,Deriv_xw,res1,res2);
    Temp[0][1]=(res1+(w/conj(w))*res2)/Temp[0][0];
    hermit2(A,B,C_A,C_B,Z,Deriv_y,Z,Deriv_yw,res1,res2);
    Temp[0][2]=(res1+(w/conj(w))*res2)/Temp[0][0];
    hermit2(A,B,C_A,C_B,Deriv_x,Deriv_x,Deriv_xw,Deriv_xw,res1,res2);

    Temp[1][1]=(nw*res1+res2/nw)/Temp[0][0];
    Tempb[1][1]=(pow2(nw)*res1+res2)/Temp[0][0];

    hermit2(A,B,C_A,C_B,Deriv_y,Deriv_y,Deriv_yw,Deriv_yw,res1,res2);
    Temp[2][2]=(nw*res1+res2/nw)/Temp[0][0];
    Tempb[2][2]=(pow2(nw)*res1+res2)/Temp[0][0];
    hermit2(A,B,C_A,C_B,Deriv_x,Deriv_y,Deriv_xw,Deriv_yw,res1,res2);
    Temp[1][2]=(nw*res1+res2/nw)/Temp[0][0];
    Tempb[1][2]=(res1*pow2(nw)+res2)/Temp[0][0];
    Temp[0][0]=1;
    Temp[2][0]=conj(Temp[0][2]);
    Temp[1][0]=conj(Temp[0][1]);
    Temp[2][1]=conj(Temp[1][2]);
    Complex DET=0;
    DET=Temp[1][1]*Temp[2][2]-pow2(abs(Temp[1][2]));
    DET-=Temp[0][1]*(Temp[1][0]*Tempb[2][2]-Temp[2][0]*Tempb[1][2]);
    DET+=Temp[0][2]*(Temp[1][0]*Temp[2][1]*pow2(nw)-Temp[2][0]*Tempb[1][1]);
    vollong= real(DET) / (pow2(K / 6.));
  }
  else
  {
    vollong=branch;
  }
}







void compute_volume(MMatrix<double> &B, MMatrix<double> &A,MMatrix<double> &C_B, MMatrix<double> &C_A,Complex x,Complex y,double nw,double &vollong,MMatrix<Complex> &Z,MMatrix<Complex> &Deriv_x,MMatrix<Complex> &Deriv_y)
{
  MMatrix<Complex>TempN(3,3);
  double vollong2;
  Complex det2b;
  {
    double partrr,partyy,partry;
    double partrrb,partyyb,partryb;
    double rpr;

    double rpra = 0;
    double rprb = 0;
    double rdya = 0;
    double rdxa = 0;
    double rdxb = 0;
    double xpxa = 0;
    double xpxb = 0;
    double ypya = 0;
    double ypyb = 0;
    double xdya = 0;
    double xdyb = 0;
    double rdyb = 0;
    int p,q,i,j,r;
    double ny=abs(y);
    double nx=abs(x);
    double pny,ppny;
    double pnx=1;
    double ppnx=1;
    Complex p_x=_1;
    Complex pp_x=1;
    Complex p_y=_1;
    Complex pp_y=1;

    for(p = 0;p<size_A;p++)
    {
      p_y=1;
      for(q = 0;q<size_A-p;q++)
      {

        Z[p][q]=p_x*p_y;

        if(p==1)
        {
          Deriv_x[p][q]=(Complex (p,0))*p_y;
        }
        if(p>1 && x==_0)
        {
          Deriv_x[p][q]=_0;
        }
        if(p>1 && x!=_0)
        {
          Deriv_x[p][q]=(Complex (p,0))*pp_x*p_y;
        }
        if(q==1)
        {
          Deriv_y[p][q]=(Complex (q,0))*p_x;
        }
        if (q>1 && y==_0)
        {
          Deriv_y[p][q]=_0;
        }
        if (q>1 && y!=_0)
        {
          Deriv_y[p][q]=(Complex (q,0))*p_x*pp_y;
        }
        pp_y=p_y;
        p_y*=y;
      }
      pp_x=p_x;
      p_x*=x;
    }
    //show(Z);
    Complex r_A,r_B,r_xA,r_xB,r_yA,r_yB,r_xxA,r_yyA,r_xyA,r_xyB,r_xxB,r_yyB;
    r_A=0;
    r_B=0;
    r_xA=0;
    r_xB=0;
    Complex r_xB2=0;
    r_yA=0;
    r_yB=0;
    Complex r_yB2=0;
    r_xyA=0;
    r_xyB=0;
    Complex r_xyB2=0;
    r_xxA=0;
    r_yyA=0;
    r_xyA=0;

    r_xxB=0;
    Complex r_xxB2=0;
    r_yyB=0;
    Complex r_yyB2=0;
    Complex w=sqrt(pow6(x)+pow6(y)+_1);

    for(p=0;p<size_A;p++)
    {
      partrr = 0;
      partyy = 0;
      partry = 0;
      pny=1;
      ppny=1;
      if(p<size_B)
      {
        partrrb = 0;
        partyyb = 0;
        partryb = 0;
      }
      for(q=0;q<size_A-p;q++)
      {
        if(q<size_B-p)
        {
          partrrb += B[p][q]*pny ;
        }
        partrr += A[p][q]*pny;
        if(q > 0)
        {
          if(q<size_B-p)
          {
            if(ny==0)
            {
              partyyb += B[p][q]* pow2(q) * ((q-1)==0?1:0);
              partryb += B[p][q]* q * ((q-1)==0?1:0);
            }
            else
            {
              partyyb += B[p][q]* pow2(q) *ppny;
              partryb += B[p][q]* q * ppny;
            }
          }
          if (ny==0)
          {
            partyy += A[p][q]* pow2(q) * ((q-1)==0?1:0);
            partry += A[p][q]* q * ((q-1)==0?1:0);
          }
          else
          {
            partyy += A[p][q]* pow2(q) * ppny;
            partry += A[p][q]* q * ppny;
          }

        }
        ppny=pny;
        pny*=pow2(ny);
      }
      rpra += partrr * pnx;
      rdya += partry * pnx;
      ypya += partyy * pnx;
      if (p<size_B)
      {
        rprb += partrrb * pnx;
        rdyb += partryb * pnx;
        ypyb +=  partyyb * pnx;
      }
      if(p > 0)
      {
        if(nx==0)
        {
          rdxa += partrr * p * ((p-1==0)?1:0);
          xpxa += partrr * pow2(p) * ((p-1==0)?1:0);
          xdya += partry * p * ((p-1==0)?1:0);
        }
        else
        {
          rdxa += partrr * p *ppnx;
          xpxa += partrr * pow2(p) * ppnx;
          xdya += partry * p * ppnx;
        }
        if(p<size_B)
        {
          if(nx==0)
          {
            rdxb += partrrb * p * ((p-1==0)?1:0);
            xpxb += partrrb * pow2(p) * ((p-1==0)?1:0);
            xdyb += partryb * p * ((p-1==0)?1:0);
          }
          else
          {
            rdxb += partrrb * p * ppnx;
            xpxb += partrrb * pow2(p) * ppnx;
            xdyb += partryb * p * ppnx;
          }
        }
      }
      ppnx=pnx;
      pnx*=pow2(nx);
    }





    Complex rpxa=Complex(rdxa,0)*x;
    Complex rpxb=Complex(rdxb,0)*x;
    Complex rpya=Complex(rdya,0)*y;
    Complex rpyb=Complex(rdyb,0)*y;
    Complex xpya=Complex(xdya,0)*conj(x)*y;
    Complex xpyb=Complex(xdyb,0)*conj(x)*y;
    Complex res1=_0;
    Complex res2=_0;


    hermit(C_A,C_B,Z,Z,res1,res2);
    rpra+=real(res1);
    rprb+=real(res2);
    rpr=rpra+pow2(nw)*rprb;
    Complex rpr2=rpra+rprb;
    double nv = sqrt(fabs(rpra * rprb / rpr));
    r_A+=real(res1);
    r_B+=real(res2)*pow2(nw);
    hermit(C_A,C_B,Z,Deriv_x,res1,res2);
    rpxa +=res1;
    rpxb +=res2;
    Complex rpx = rpxa + Complex(pow2(nw),0)* rpxb;
    Complex rpx2=rpxa+rpxb;


    hermit(C_A,C_B,Z,Deriv_y,res1,res2);
    rpya +=res1;
    rpyb +=res2;
    Complex rpy = rpya + Complex(pow2(nw),0)* rpyb;
    Complex rpy2=rpya+rpyb;

    hermit(C_A,C_B,Deriv_x,Deriv_y,res1,res2);

    xpya += res1;
    xpyb += res2;
    Complex xpy = xpya + Complex(pow2(nw),0)* xpyb;
    Complex xpy2=xpya+xpyb;

    hermit(C_A,C_B,Deriv_x,Deriv_x,res1,res2);
    xpxa += real(res1);
    xpxb += real(res2);
    double xpx = xpxa + pow2(nw) * xpxb;
    Complex xpx2=xpxa+xpxb;
    hermit(C_A,C_B,Deriv_y,Deriv_y,res1,res2);
    ypya += real(res1);
    ypyb += real(res2);
    double ypy = ypya + pow2(nw) * ypyb;
    Complex ypy2=ypya+ypyb;
    TempN[0][0]=rpr;
    TempN[0][1]=rpx;
    TempN[0][2]=rpy;

    TempN[1][2]=xpy;
    TempN[1][1]=xpx;
    TempN[2][2]=ypy;
    TempN[2][0]=conj(TempN[0][2]);
    TempN[1][0]=conj(TempN[0][1]);
    TempN[2][1]=conj(TempN[1][2]);
    det2b=determinant3x3(TempN);
    Complex Qx=Complex((rpra * real(rpxb) - rprb * real(rpxa)) / rpr,-(rpra * imag(rpxb) - rprb * imag(rpxa)) / rpr);
    Complex Qy=Complex((rpra * real(rpyb) - rprb * real(rpya)) / rpr, -(rpra * imag(rpyb) - rprb * imag(rpya)) / rpr);
    double delx2 = xpx - abs(rpx)*abs(rpx) / rpr;
    double dely2 = ypy - abs(rpy)*abs(rpy) / rpr;
    Complex delxy = xpy-  ( conj(rpx)*rpy / rpr);

    Complex cof1=xpx*ypy-xpy*conj(xpy);
    Complex cof2=conj(rpx)*ypy-xpy*conj(rpy);
    Complex cof3=conj(rpx)*conj(xpy)-xpx*conj(rpy);
    Complex alpha=rpr2*cof1;
    Complex beta=rpx2*cof2;
    Complex gamma=rpy2*cof3;
    double DET = real(alpha - beta + gamma);
    vollong2 = DET / (pow3(rpr)* pow2(K/6.));

    double nfx= 3. * pow5(nx);
    double nfy= 3. * pow5(ny);
    Complex fx=Complex (3,0) * pow5(x);
    Complex fy=Complex (3,0) * pow5(y);
    double cross=real(fx*Qy*conj(fy*Qx));
    double vol1=(pow2(nw) * (delx2 * dely2 - pow2(abs(delxy)))) / pow2(rpr);
    double vol22=-( pow2(nw)*(pow2(nfx)*pow2(abs(Qy)) + pow2(nfy)*pow2(abs(Qx)) - 2*cross)) / pow2(rpr);
    cross=real(fx*conj(fy*delxy));
    Complex w2=pow6(x)+pow6(y)+_1;
    double vol21 = pow2(nv) * (pow2(nfy) * delx2 + pow2(nfx) * dely2 - 2 * cross)/pow2(rpr);
    double vol31 = 2*(dely2 * real(fx*conj(w2*Qx)) + delx2 * real(fy*conj(w2*Qy))) / pow2(rpr);
    double vol32 = -2*(real(Qy*w2*conj(fx)*delxy)+real(fy*delxy*conj(Qx*w2)))/pow2(rpr);
    vollong = (vol1 + vol21 + vol22 + vol31 + vol32)/pow2(K/6.);
  }
}







void hermit2(MMatrix<double>&A,MMatrix<double>&B,MMatrix<double> &C_A,MMatrix <double> &C_B,MMatrix<Complex> &Z1,MMatrix<Complex> &W1,MMatrix<Complex> &Z2,MMatrix<Complex> &W2,Complex &res1,Complex &res2)
{

  double multip;
  int i,j,r,p2,p1,q1,q2;
  Complex term1;
  res1 = _0;
  res2 = _0;
  for(i=0;i<A.getHeight();i++)
  {
    for(j=0;j<A.getHeight()-i;j++)
    {
      res1+=A[i][j]*(Z1[i][j]*conj(W1[i][j]));
      if(i<B.getHeight() && j<B.getHeight()-i)
      {
        res2+=B[i][j]*(Z2[i][j]*conj(W2[i][j]));
      }
    }
  }

  j=Nondiagonalterms_B.getWidth()/4;

  for(i=0;i<min(C_B.getHeight(),Nondiagonalterms_B.getHeight()) ;i++)
  {
    term1=_0;
    for(r = 0;r<j;r++)
    {
      p1 = Nondiagonalterms_B[i][0+4*r];
      q1 = Nondiagonalterms_B[i][1+4*r];
      p2 = Nondiagonalterms_B[i][2+4*r];
      q2 = Nondiagonalterms_B[i][3+4*r];
      if (r==0) multip=(p1==size_B-1-(p1-6+q1))? 0.5:1;

      term1+=Z2[p1][q1]*conj(W2[p2][q2])+Z2[q1][p1]*conj(W2[q2][p2])+Z2[p2][q2]*conj(W2[p1][q1])
             +Z2[q2][p2]*conj(W2[q1][p1]);
    }
    res2+=(Complex (C_B[i][0]*multip,0))*term1;
  }
  j=Nondiagonalterms_A.getWidth()/4;
  for(i=0;i<min(C_A.getHeight(),Nondiagonalterms_A.getHeight());i++)
  {
    term1=_0;
    for(r = 0;r<j;r++)
    {
      p1 = Nondiagonalterms_A[i][0+4*r];
      q1 = Nondiagonalterms_A[i][1+4*r];
      p2 = Nondiagonalterms_A[i][2+4*r];
      q2 = Nondiagonalterms_A[i][3+4*r];
      if (r==0) multip=(p1==size_A-1-(p1-6+q1))? 0.5:1;
      term1+=Z1[p1][q1]*conj(W1[p2][q2])+Z1[q1][p1]*conj(W1[q2][p2])+Z1[p2][q2]*conj(W1[p1][q1])
             +Z1[q2][p2]*conj(W1[q1][p1]);

    }
    res1+=(Complex (C_A[i][0]*multip,0))*term1;
  }
}









void hermit(MMatrix<double> &C_A,MMatrix <double> &C_B,MMatrix<Complex> &Z,MMatrix<Complex> &W,Complex &res1,Complex &res2)
{

  double multip;
  int i,j,r,p2,p1,q1,q2;
  Complex term1;
  res1 = _0;
  res2 = _0;
  j=Nondiagonalterms_B.getWidth()/4;
  for(i=0;i<min(C_B.getHeight(),Nondiagonalterms_B.getHeight()) ;i++)
  {
    term1=_0;
    for(r = 0;r<j;r++)
    {
      p1 = Nondiagonalterms_B[i][0+4*r];
      q1 = Nondiagonalterms_B[i][1+4*r];
      p2 = Nondiagonalterms_B[i][2+4*r];
      q2 = Nondiagonalterms_B[i][3+4*r];
      if (r==0) multip=(p1==size_B-1-(p1-6+q1))? 0.5:1;
      term1+=Z[p1][q1]*conj(W[p2][q2])+Z[q1][p1]*conj(W[q2][p2])+Z[p2][q2]*conj(W[p1][q1])
             +Z[q2][p2]*conj(W[q1][p1]);
    }
    res2+=(Complex (C_B[i][0]*multip,0))*term1;
  }
  j=Nondiagonalterms_A.getWidth()/4;
  for(i=0;i<min(C_A.getHeight(),Nondiagonalterms_A.getHeight());i++)
  {
    term1=_0;
    for(r = 0;r<j;r++)
    {
      p1 = Nondiagonalterms_A[i][0+4*r];
      q1 = Nondiagonalterms_A[i][1+4*r];
      p2 = Nondiagonalterms_A[i][2+4*r];
      q2 = Nondiagonalterms_A[i][3+4*r];
      if (r==0) multip=(p1==size_A-1-(p1-6+q1))? 0.5:1;
      term1+=Z[p1][q1]*conj(W[p2][q2])+Z[q1][p1]*conj(W[q2][p2])+Z[p2][q2]*conj(W[p1][q1])
             +Z[q2][p2]*conj(W[q1][p1]);
    }
    res1+=(Complex (C_A[i][0]*multip,0))*term1;
  }
}






void write_results_in_file(double mass)
{
  cout << "Writing data in file " << name_file <<endl;
  ofstream file(name_file.c_str(),ofstream::app);
  file << "--------------------------------------------------------" << endl <<endl;
  file << "Final results :" << endl << endl;
  file << "Matrix A\n"  << A << endl;
  A.writeToStream(file);
  file << endl << endl << "Matrix B\n" << B << endl;
  B.writeToStream(file);
  file << endl << endl << "Matrix C_A\n"  << C_A << endl;
  C_A.writeToStream(file);
  file << endl << endl << "Matrix C_B\n"  << C_B << endl;
  C_B.writeToStream(file);
  file << endl << endl << "Mass " << mass << endl;
  file << "\n -- Time of computation : " << seconds <<" sec " <<endl;
  file.close();

}



void create_matrices(int K)
{

  if(K>=6)
  {
  
    size_A=K+1;
    size_B=K+1-3;

  }
  A.resize(size_A,size_A);
  B.resize(size_B,size_B);
  Z.resize(size_A,size_A);
  Deriv_x.resize(size_A,size_A);
  Deriv_y.resize(size_A,size_A);
  Zw.resize(size_A,size_A);
  Deriv_xw.resize(size_A,size_A);
  Deriv_yw.resize(size_A,size_A);
  generate_diagonal_terms(K);
  generate_non_diagonal_terms(K);

}


void generate_non_diagonal_terms(int K)
{
  int i,j,p;
  Nondiagonalterms_B.resize(Inverseterms_B2.getHeight(),12);
  for(p=0;p<Inverseterms_B2.getHeight();p++)
  {
    i=Inverseterms_B2[p][1]+6;
    j=Inverseterms_B2[p][0];
    Nondiagonalterms_B[p][0]=i;   //r==1
    Nondiagonalterms_B[p][1]=j;
    Nondiagonalterms_B[p][2]=i-6;
    Nondiagonalterms_B[p][3]=j;
    Nondiagonalterms_B[p][4]=j;  //r==2
    Nondiagonalterms_B[p][5]=(size_B-1) - (i+j);
    Nondiagonalterms_B[p][6]=j;
    Nondiagonalterms_B[p][7]=(size_B-1) - (i+j-6);
    Nondiagonalterms_B[p][8]=(size_B-1) - (i+j);  //r==3
    Nondiagonalterms_B[p][9]=i;
    Nondiagonalterms_B[p][10]=(size_B-1) - (i+j-6);
    Nondiagonalterms_B[p][11]=i-6;
  }
  MMatrix <int> Nondiagonalterms_Atemp((size_A-6)*(size_A+1-6)/2,12);
  p=0;
  for(i=6;i<size_A;i++)
  {
    for(j=0;i+j<size_A;j++)
    {
      if((i==6) || (size_A-1-(i+j)>=j && size_A-1-(i-6+j)>=i))
      {

        Nondiagonalterms_Atemp[p][0]=i;
        Nondiagonalterms_Atemp[p][1]=j;
        Nondiagonalterms_Atemp[p][2]=i-6;
        Nondiagonalterms_Atemp[p][3]=j;
        Nondiagonalterms_Atemp[p][4]=j;  //r==2
        Nondiagonalterms_Atemp[p][5]=(size_A-1) - (i+j);
        Nondiagonalterms_Atemp[p][6]=j;
        Nondiagonalterms_Atemp[p][7]=(size_A-1) - (i+j-6);
        Nondiagonalterms_Atemp[p][8]=(size_A-1) - (i+j);  //r==3
        Nondiagonalterms_Atemp[p][9]=i;
        Nondiagonalterms_Atemp[p][10]=(size_A-1) - (i+j-6);
        Nondiagonalterms_Atemp[p][11]=i-6;
        p++;
      }
    }
  }
  
}


void generate_diagonal_terms(int K)
{
  int i,j,p,q;
  int l=0;
  MMatrix <int> Diagonalterms_Btemp(size_B,size_B);
  MMatrix <int> Diagonalterms_Atemp(size_A,size_A);
  for(i=0;i<size_B;i++)
  {
    for(j=0;i+j<size_B;j++)
    {
      if  (Diagonalterms_Btemp[j][i]==0)
      {
        Diagonalterms_B.resize(Diagonalterms_B.getHeight()+1,2);
        Diagonalterms_B[l][0]=j;
        Diagonalterms_B[l][1]=i;
        l++;
        Diagonalterms_Btemp[j][i]=1;
        symmetry(Diagonalterms_Btemp);
      }
    }
  }
  l=0;
  for(i=0;i<size_A;i++)
  {
    for(j=0;i+j<size_A;j++)
    {
      if  (Diagonalterms_Atemp[j][i]==0)
      {
        Diagonalterms_A.resize(Diagonalterms_A.getHeight()+1,2);
        Diagonalterms_A[l][0]=j;
        Diagonalterms_A[l][1]=i;
        l++;
        Diagonalterms_Atemp[j][i]=1;
        symmetry(Diagonalterms_Atemp);
      }
    }
  }
  
  
  generate_non_diagonal_terms2(K);
}

template<typename T>
void symmetry(MMatrix<T> &M)
{
  int p,q;
  int size=M.getHeight();
  for(p=0;p<size;p++)
  {
    for(q=p+1;q<size;q++)
    {
      M[p][q]=M[q][p];
    }
  }
  for(p=0;p<size;p++)
  {
    for(q=0;q<size-p;q++)
    {
      if((p/((size-1.)/2.) + q/(size-1.)>1) && (p>=q))
      {
        M[p][q]=M[q][size-1-(p+q)];
      }
    }
  }
  for(p=0;p<size;p++)
  {
    for(q=p+1;q<size;q++)
    {
      M[p][q]=M[q][p];
    }
  }
}
void generate_inverse_terms(int K)
{
  int k,p,q,l;
  bool already;
  Inverseterms_A.resize(1,3);
  for(p=1;p<Nondiagonalterms_A.getHeight();p++)
  {
    k=0;l=Inverseterms_A.getHeight();already=0;
    while(k<l && already==0)
    {
      if(   (Nondiagonalterms_A[p][0] %6==Nondiagonalterms_A[Inverseterms_A[k][0]][1] %6 &&
             Nondiagonalterms_A[p][1] %6== Nondiagonalterms_A[Inverseterms_A[k][0]][0] %6)
            || (Nondiagonalterms_A[p][4] %6==Nondiagonalterms_A[Inverseterms_A[k][0]][5] % 6 &&
                Nondiagonalterms_A[p][5] %6== Nondiagonalterms_A[Inverseterms_A[k][0]][4] % 6)
            || (Nondiagonalterms_A[p][8] %6==Nondiagonalterms_A[Inverseterms_A[k][0]][9] %6 &&
                Nondiagonalterms_A[p][9] %6== Nondiagonalterms_A[Inverseterms_A[k][0]][8] %6))
      {
        already=1;q=1;
        bool stop=0;
        while(q<Inverseterms_A.getWidth() && stop==0)
        {
          if(Inverseterms_A[k][q]==Inverseterms_A[k][0])
          {
            Inverseterms_A[k][q]=p;
            stop=1;
          }
          q++;
        }
      }
      k++;
    }
    if (already==0)
    {
      Inverseterms_A.resize(Inverseterms_A.getHeight()+1,Inverseterms_A.getWidth());
      for(q=0;q<Inverseterms_A.getWidth();q++)
      {
        Inverseterms_A[Inverseterms_A.getHeight()-1][q]=p;
      }
    }
  }
    
}

void generate_non_diagonal_terms2(int K)
{
  int i,p;
  for(i=0;i<Diagonalterms_A.getHeight();i++)
  {
    if(Diagonalterms_A[i][0]+Diagonalterms_A[i][1]+6<=size_A-1)
    {
      Inverseterms_A2.resize(Inverseterms_A2.getHeight()+1,2);
      Inverseterms_A2[Inverseterms_A2.getHeight()-1][0]=Diagonalterms_A[i][0];
      Inverseterms_A2[Inverseterms_A2.getHeight()-1][1]=Diagonalterms_A[i][1];
    }
  }
  for(i=0;i<Diagonalterms_B.getHeight();i++)
  {
    if(Diagonalterms_B[i][0]+Diagonalterms_B[i][1]+6<=size_B-1)
    {
      Inverseterms_B2.resize(Inverseterms_B2.getHeight()+1,2);
      Inverseterms_B2[Inverseterms_B2.getHeight()-1][0]=Diagonalterms_B[i][0];
      Inverseterms_B2[Inverseterms_B2.getHeight()-1][1]=Diagonalterms_B[i][1];
    }
  }
  
  int couple[2];
  for(i=0;i<Inverseterms_A2.getHeight();i++)
  {
    couple[0]=Inverseterms_A2[i][0];
    couple[1]=Inverseterms_A2[i][1];
    if (!(present(couple,Matrices_Inverseterms_A)))
    {
      Matrices_Inverseterms_A.resize(Matrices_Inverseterms_A.getHeight()+1,6);
      Matrices_Inverseterms_A[Matrices_Inverseterms_A.getHeight()-1][0]=couple[0];
      Matrices_Inverseterms_A[Matrices_Inverseterms_A.getHeight()-1][1]=couple[1];
      Matrices_Inverseterms_A[Matrices_Inverseterms_A.getHeight()-1][2]=max(couple[1],size_A-1-(couple[0]+couple[1]+6));
      Matrices_Inverseterms_A[Matrices_Inverseterms_A.getHeight()-1][3]=min(couple[1],size_A-1-(couple[0]+couple[1]+6));
      Matrices_Inverseterms_A[Matrices_Inverseterms_A.getHeight()-1][4]=max(couple[0],size_A-1-(couple[0]+couple[1]+6));
      Matrices_Inverseterms_A[Matrices_Inverseterms_A.getHeight()-1][5]=min(couple[0],size_A-1-(couple[0]+couple[1]+6));


    }

  }

  for(i=0;i<Inverseterms_B2.getHeight();i++)
  {
    couple[0]=Inverseterms_B2[i][0];
    couple[1]=Inverseterms_B2[i][1];
    if (!(present(couple,Matrices_Inverseterms_B)))
    {
      Matrices_Inverseterms_B.resize(Matrices_Inverseterms_B.getHeight()+1,6);
      Matrices_Inverseterms_B[Matrices_Inverseterms_B.getHeight()-1][0]=couple[0];
      Matrices_Inverseterms_B[Matrices_Inverseterms_B.getHeight()-1][1]=couple[1];
      Matrices_Inverseterms_B[Matrices_Inverseterms_B.getHeight()-1][2]=max(couple[1],size_B-1-(couple[0]+couple[1]+6));
      Matrices_Inverseterms_B[Matrices_Inverseterms_B.getHeight()-1][3]=min(couple[1],size_B-1-(couple[0]+couple[1]+6));
      Matrices_Inverseterms_B[Matrices_Inverseterms_B.getHeight()-1][4]=max(couple[0],size_B-1-(couple[0]+couple[1]+6));
      Matrices_Inverseterms_B[Matrices_Inverseterms_B.getHeight()-1][5]=min(couple[0],size_B-1-(couple[0]+couple[1]+6));
    }
  }
  

  Inverseterms_C_A.resize(Matrices_Inverseterms_A.getHeight(),3);
  Inverseterms_C_B.resize(Matrices_Inverseterms_B.getHeight(),3);
  int l=0;
  for(i=0;i<Matrices_Inverseterms_A.getHeight();i++)
  {
    if (Matrices_Inverseterms_A[i][2]==Matrices_Inverseterms_A[i][0] &&
        Matrices_Inverseterms_A[i][3]==Matrices_Inverseterms_A[i][1] &&
        Matrices_Inverseterms_A[i][4]==Matrices_Inverseterms_A[i][2] &&
        Matrices_Inverseterms_A[i][5]==Matrices_Inverseterms_A[i][3])
    {
      Inverseterms_C_A[i][0]=l;
      Inverseterms_C_A[i][1]=l;
      Inverseterms_C_A[i][2]=l;
      fill_Nondiagonalterms_A(Matrices_Inverseterms_A[i][1],Matrices_Inverseterms_A[i][0]);

    }
    else
    {
      if (Matrices_Inverseterms_A[i][2]==Matrices_Inverseterms_A[i][0] &&
          Matrices_Inverseterms_A[i][3]==Matrices_Inverseterms_A[i][1] )
      {
        Inverseterms_C_A[i][0]=l;
        fill_Nondiagonalterms_A(Matrices_Inverseterms_A[i][5],Matrices_Inverseterms_A[i][4]);
        l++;
        Inverseterms_C_A[i][1]=l;

        fill_Nondiagonalterms_A(Matrices_Inverseterms_A[i][3],Matrices_Inverseterms_A[i][2]);
        Inverseterms_C_A[i][2]=l;
      }
      else
      {
        if (Matrices_Inverseterms_A[i][2]==Matrices_Inverseterms_A[i][4] &&
            Matrices_Inverseterms_A[i][3]==Matrices_Inverseterms_A[i][5] )
        {
          Inverseterms_C_A[i][0]=l;
          fill_Nondiagonalterms_A(Matrices_Inverseterms_A[i][5],Matrices_Inverseterms_A[i][4]);
          Inverseterms_C_A[i][1]=l;
          l++;
          Inverseterms_C_A[i][2]=l;
          fill_Nondiagonalterms_A(Matrices_Inverseterms_A[i][1],Matrices_Inverseterms_A[i][0]);

        }
        else
        {
          if (Matrices_Inverseterms_A[i][0]==Matrices_Inverseterms_A[i][4] &&
              Matrices_Inverseterms_A[i][1]==Matrices_Inverseterms_A[i][5] )
          {
            Inverseterms_C_A[i][0]=l;
            Inverseterms_C_A[i][2]=l;
            fill_Nondiagonalterms_A(Matrices_Inverseterms_A[i][0],Matrices_Inverseterms_A[i][1]);

            l++;
            Inverseterms_C_A[i][1]=l;
            fill_Nondiagonalterms_A(Matrices_Inverseterms_A[i][2],Matrices_Inverseterms_A[i][3]);
          }
          else
          {
            Inverseterms_C_A[i][0]=l;
            l++;
            Inverseterms_C_A[i][1]=l;
            l++;
            Inverseterms_C_A[i][2]=l;

            fill_Nondiagonalterms_A(Matrices_Inverseterms_A[i][5],Matrices_Inverseterms_A[i][4]);
            fill_Nondiagonalterms_A(Matrices_Inverseterms_A[i][3],Matrices_Inverseterms_A[i][2]);
            fill_Nondiagonalterms_A(Matrices_Inverseterms_A[i][1],Matrices_Inverseterms_A[i][0]);


          }
        }
      }
    }
    l++;


  }
  C_A.resize(l,1);
  l=0;
  for(i=0;i<Matrices_Inverseterms_B.getHeight();i++)
  {
    if (Matrices_Inverseterms_B[i][2]==Matrices_Inverseterms_B[i][0] &&
        Matrices_Inverseterms_B[i][3]==Matrices_Inverseterms_B[i][1] &&
        Matrices_Inverseterms_B[i][4]==Matrices_Inverseterms_B[i][2] &&
        Matrices_Inverseterms_B[i][5]==Matrices_Inverseterms_B[i][3])
    {
      Inverseterms_C_B[i][0]=l;
      Inverseterms_C_B[i][1]=l;
      Inverseterms_C_B[i][2]=l;
      fill_Nondiagonalterms_B(Matrices_Inverseterms_B[i][1],Matrices_Inverseterms_B[i][0]);

    }
    else
    {
      if (Matrices_Inverseterms_B[i][2]==Matrices_Inverseterms_B[i][0] &&
          Matrices_Inverseterms_B[i][3]==Matrices_Inverseterms_B[i][1] )
      {
        Inverseterms_C_B[i][0]=l;
        fill_Nondiagonalterms_B(Matrices_Inverseterms_B[i][5],Matrices_Inverseterms_B[i][4]);
        l++;
        Inverseterms_C_B[i][1]=l;

        fill_Nondiagonalterms_B(Matrices_Inverseterms_B[i][3],Matrices_Inverseterms_B[i][2]);
        Inverseterms_C_B[i][2]=l;
      }
      else
      {
        if (Matrices_Inverseterms_B[i][2]==Matrices_Inverseterms_B[i][4] &&
            Matrices_Inverseterms_B[i][3]==Matrices_Inverseterms_B[i][5] )
        {
          Inverseterms_C_B[i][0]=l;
          fill_Nondiagonalterms_B(Matrices_Inverseterms_B[i][5],Matrices_Inverseterms_B[i][4]);
          Inverseterms_C_B[i][1]=l;
          l++;
          Inverseterms_C_B[i][2]=l;
          fill_Nondiagonalterms_B(Matrices_Inverseterms_B[i][1],Matrices_Inverseterms_B[i][0]);

        }
        else
        {
          if (Matrices_Inverseterms_B[i][0]==Matrices_Inverseterms_B[i][4] &&
              Matrices_Inverseterms_B[i][1]==Matrices_Inverseterms_B[i][5] )
          {
            Inverseterms_C_B[i][0]=l;
            Inverseterms_C_B[i][2]=l;
            fill_Nondiagonalterms_B(Matrices_Inverseterms_B[i][0],Matrices_Inverseterms_B[i][1]);

            l++;
            Inverseterms_C_B[i][1]=l;
            fill_Nondiagonalterms_B(Matrices_Inverseterms_B[i][2],Matrices_Inverseterms_B[i][3]);
          }
          else
          {
            Inverseterms_C_B[i][0]=l;
            l++;
            Inverseterms_C_B[i][1]=l;
            l++;
            Inverseterms_C_B[i][2]=l;

            fill_Nondiagonalterms_B(Matrices_Inverseterms_B[i][5],Matrices_Inverseterms_B[i][4]);
            fill_Nondiagonalterms_B(Matrices_Inverseterms_B[i][3],Matrices_Inverseterms_B[i][2]);
            fill_Nondiagonalterms_B(Matrices_Inverseterms_B[i][1],Matrices_Inverseterms_B[i][0]);


          }
        }
      }
    }
    l++;


  }

  update_new_C_A.resize(C_A.getHeight(),C_A.getWidth());
  
  if(l>0)
  {
    C_B.resize(l,1);
    update_new_C_B.resize(C_B.getHeight(),C_B.getWidth());
  }






}
bool present(int* c,MMatrix<int> M)
{
  int i;
  bool result=false;
  for(i=0;i<M.getHeight();i++)
  {
    if ((c[0]==M[i][0] && c[1]==M[i][1]) || (c[0]==M[i][2] && c[1]==M[i][3]) || (c[0]==M[i][4] && c[1]==M[i][5]))
    {
      result=true;
    }

  }
  return(result);
}

void fill_Nondiagonalterms_A(int m,int n)
{

  int size;
  size=(K>12)?12+12*((K-12)/3):12;
  Nondiagonalterms_A.resize(Nondiagonalterms_A.getHeight()+1,size);
  int it,jt,pt;
  it=m+6;
  jt=(size_A-1)-(6+m+n);

  pt=Nondiagonalterms_A.getHeight()-1;
  Nondiagonalterms_A[pt][0]=it;
  Nondiagonalterms_A[pt][1]=jt;
  Nondiagonalterms_A[pt][2]=it-6;
  Nondiagonalterms_A[pt][3]=jt;
  Nondiagonalterms_A[pt][4]=jt;  //r==2
  Nondiagonalterms_A[pt][5]=(size_A-1) - (it+jt);
  Nondiagonalterms_A[pt][6]=jt;
  Nondiagonalterms_A[pt][7]=(size_A-1) - (it+jt-6);
  Nondiagonalterms_A[pt][8]=(size_A-1) - (it+jt);  //r==3
  Nondiagonalterms_A[pt][9]=it;
  Nondiagonalterms_A[pt][10]=(size_A-1) - (it+jt-6);
  Nondiagonalterms_A[pt][11]=it-6;
  if (size>12)
  {
    Nondiagonalterms_A[pt][12]=it;
    Nondiagonalterms_A[pt][13]=jt;
    Nondiagonalterms_A[pt][14]=it-6;
    Nondiagonalterms_A[pt][15]=jt+6;

    Nondiagonalterms_A[pt][16]=jt+6;
    Nondiagonalterms_A[pt][17]=(size_A-1) - (it+jt);
    Nondiagonalterms_A[pt][18]=jt;
    Nondiagonalterms_A[pt][19]=(size_A-1) - (it+jt-6);

    Nondiagonalterms_A[pt][20]=(size_A-1) - (it+jt);
    Nondiagonalterms_A[pt][21]=it;
    Nondiagonalterms_A[pt][22]=(size_A-1) - (it+jt);
    Nondiagonalterms_A[pt][23]=it-6;
  }
  if (size>24)
  {
    Nondiagonalterms_A[pt][13]=(size_A-1) - (it+jt);
    Nondiagonalterms_A[pt][12]=it+12;
    Nondiagonalterms_A[pt][15]=it+12;
    Nondiagonalterms_A[pt][14]=jt;
    //show(Nondiagonalterms_A);
  }
}
void fill_Nondiagonalterms_B(int m,int n)
{
  int size;
  size=(K>15)?12+12*((K-15)/3):12;
  //printf("%d",size);
  Nondiagonalterms_B.resize(Nondiagonalterms_B.getHeight()+1,size);
  int it,jt,pt;
  it=m+6;
  jt=(size_B-1)-(6+m+n);

  pt=Nondiagonalterms_B.getHeight()-1;
  Nondiagonalterms_B[pt][0]=it;
  Nondiagonalterms_B[pt][1]=jt;
  Nondiagonalterms_B[pt][2]=it-6;
  Nondiagonalterms_B[pt][3]=jt;
  if(size>4)
  {
    Nondiagonalterms_B[pt][4]=jt;  //r==2
    Nondiagonalterms_B[pt][5]=(size_B-1) - (it+jt);
    Nondiagonalterms_B[pt][6]=jt;
    Nondiagonalterms_B[pt][7]=(size_B-1) - (it+jt-6);
    Nondiagonalterms_B[pt][8]=(size_B-1) - (it+jt);  //r==3
    Nondiagonalterms_B[pt][9]=it;
    Nondiagonalterms_B[pt][10]=(size_B-1) - (it+jt-6);
    Nondiagonalterms_B[pt][11]=it-6;

  }
  if (size>12)
  {
    Nondiagonalterms_B[pt][12]=it;
    Nondiagonalterms_B[pt][13]=jt;
    Nondiagonalterms_B[pt][14]=it-6;
    Nondiagonalterms_B[pt][15]=jt+6;

    Nondiagonalterms_B[pt][16]=jt+6;
    Nondiagonalterms_B[pt][17]=(size_B-1) - (it+jt);
    Nondiagonalterms_B[pt][18]=jt;
    Nondiagonalterms_B[pt][19]=(size_B-1) - (it+jt-6);

    Nondiagonalterms_B[pt][20]=(size_B-1) - (it+jt);
    Nondiagonalterms_B[pt][21]=it;
    Nondiagonalterms_B[pt][22]=(size_B-1) - (it+jt);
    Nondiagonalterms_B[pt][23]=it-6;
  }
  if (size>16)
  {
    Nondiagonalterms_B[pt][13]=(size_B-1) - (it+jt);
    Nondiagonalterms_B[pt][12]=it+12;
    Nondiagonalterms_B[pt][15]=it+12;
    Nondiagonalterms_B[pt][14]=jt;
  }
}

