/***************************************************************************
 *   Copyright (C) 2006 by Julien Keller                                   *
 *   j.keller@imperial.ac.uk                                               *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/



#include <complex>
#include "MMatrix.h"  //Contains library to handle quickly matrices in memory
#define Complex  std::complex<double>


/* Procedures to print nicely the matrices */
void show(MMatrix<double>);
void show(MMatrix<int>);
void show(MMatrix<Complex>); /* Extending previous procedure to Complex data */
void show(MMatrix<double>,char*); /* Show the matrix && a string */

void reinitialise(MMatrix<double>&);
MMatrix<double> inverse_elements(MMatrix<double>);  /* inverse elements for half of the matrix */
MMatrix<double> transpose(MMatrix<double>);  // normal transpose
MMatrix<double> transpose2(MMatrix<double>);	// see the code
double  scalar_product(MMatrix<double>,MMatrix<double>); /* scalar product of two vectors */	

/* These procedures can always be improved */
MMatrix<double> multiply(MMatrix<double>,MMatrix<double>); /* Simple procedure to multiply 2 matrices */
void mult(MMatrix<double>&,MMatrix<double>);
MMatrix<double> inverse(MMatrix<double>); /* Inverse the matrix */
double determinant(MMatrix<double>);
Complex determinant3x3(MMatrix<Complex>); /* as before but just for 3x3 matrices */
double spectral_radius(MMatrix<double>);
void MJacobi(MMatrix <double>,MMatrix <double>&);




